/*
 * Copyright (c) 2001-2009, TIBCO Software Inc.
 * Use, modification, and distribution subject to terms of license.
 */

jsx3.Class.defineClass("jsx3.ide.ui.PlugIn", jsx3.amp.PlugIn, null, function(PlugIn, PlugIn_prototype) {

  var ui = jsx3.ide.ui;
  var amp = jsx3.amp;

  ui.CONTENT = {
  };

  PlugIn_prototype.onLoaded = function() {
    this._menuManager = new amp.util.MenuManager();
    this._paletteManager = new ui.PaletteManager();
    this._paletteManager.setMenuManager(this._menuManager);
    this._paletteManager.setPlugIn(this);
  };

  PlugIn_prototype.getMenuManager = function() {
    return this._menuManager;
  };
 
  PlugIn_prototype.getPaletteManager = function() {
    return this._paletteManager;
  };

  PlugIn_prototype.getPalette = function(objOwner, strId) {
    return this._paletteManager ? this._paletteManager.getPalette(objOwner.getId() + "." + strId) : null;
  };

  /* Extension point: jsx3.amp.main.layout */
  PlugIn_prototype.paintLayout = function __PlugIn_prototype_paintLayout(objContainer) {
    var layout = this.loadRsrcComponent("layout", objContainer, false);
    var mainMenu = layout.getDescendantOfName("mainMenu");

    // Insert any extensions to the menubar.
    try {
      var exts = this.getExtPoint("menubar-ext").processExts();
      var objChild = exts[0];
      var intPersist, strSourceURL, strNS;
      var Model = jsx3.app.Model;
      {
          //find out the server that will own this object instance
          var bFragment = false;
          if (strNS == null && mainMenu._jsxns == null) {
              strNS = Model.FRAGMENTNS;
          } else if (strNS != null) {
              bFragment = true;
          } else {
              strNS = mainMenu._jsxns;
          }

          var objServer = mainMenu.getServer();
          if (!objServer)
              objServer.die();
          alert("we got here: " + objServer);
      }
    } catch (exc) {
      document.write("<pre>" + exc.stack + "</pre>");
      throw exc;
    }
  };

  PlugIn_prototype.paintIDELayout = function(objContainer) {};

  PlugIn_prototype.setProgress = function() {};

  PlugIn_prototype.onComplete = function() {
    if (this._progimage && this._progimage._progon) {
      this._progimage._progon = false;
      this._progimage.setSrc("images/progress_off.gif");
      this._progimage.repaint();
      jsx3.html.updateCSSOpacity(this._progimage.getRendered(), .25);
    }
  };

  PlugIn_prototype.createProjectPathExt = function() {
    var b = this._projectpath = new jsx3.gui.Block();
    b.setText();
    b.setPadding("6 16 1 8");
    b.setHeight("100%");
    b.setBorder("0px;2px dotted #9898a5;0px;0px");
    b.setMenu("jsxmenu_apppath");

    if (jsx3.ide.PROJECT)
      this._setProjectPath();
    else
      jsx3.IDE.subscribe("startup", this, "_setProjectPath");
    
    return b;
  };

  PlugIn_prototype._setProjectPath = function() {
    var dir = jsx3.ide.getActiveProjectDirectory();
    if (dir) {
      this._projectpath.setText('<nobr><a target="_new" style="color:darkblue;" href="' + 
            dir.toURI() + '">' + jsx3.ide.PROJECT.getPathFromHome() + '</a></nobr>', true);
    }
  };
});

jsx3.Class.defineClass("jsx3.ide.ui.DialogToolPlugIn", jsx3.amp.PlugIn, null, function(DialogToolPlugIn, DialogToolPlugIn_prototype) {

  DialogToolPlugIn_prototype._compname = null;

  DialogToolPlugIn_prototype.openTool = function() {};

  DialogToolPlugIn_prototype.getSingleInstance = function() {};

  DialogToolPlugIn_prototype.getToolResource = function() {};

  DialogToolPlugIn_prototype.getToolContainer = function() {};

  DialogToolPlugIn_prototype.isMultiInstance = function() {};

});
