



 if (jsx3.CLASS_LOADER.IE) {

jsx3.Class.defineClass("jsx3.EVT", null, [jsx3.util.EventDispatcher], function(EVT, EVT_prototype) {

  
  EVT_prototype.init = function(e) {
    // clone the event object because keeping a JS reference to it is not enough to make it available after subsequent events
    if (e)
      this.e = jsx3.clone(e);
  };

  
  EVT_prototype.handleEvent = function(strType, bReturn) {
    var objEvent = jsx3.gui.Event.getCurrent();

    if (objEvent == null) {
      jsx3.util.Logger.getLogger(EVT.jsxclass.getName()).warn("handleEvent called when current event null: " + strType);
      return;
    }

    if (objEvent.getType() != strType.substring(2))
      jsx3.util.Logger.getLogger(EVT.jsxclass.getName()).warn("handleEvent called for type that does not match the current event's type: " + objEvent.getType() + " " + strType);

    jsx3.gui.Event.publish(objEvent);
  };

  
  EVT_prototype.registerEvent = function(EVENTTYPE, strCode) {
    if (EVENTTYPE.indexOf("on") == 0)
      EVENTTYPE = EVENTTYPE.substring(2);

    jsx3.gui.Event.subscribe(EVENTTYPE, function(){ jsx3.eval(strCode); } );
  };

  
  EVT_prototype.event = function(){return this.e || window.event;};
  
  EVT_prototype._event = function(){return this.e || window.event;};

  
  EVT_prototype.srcElement = function(){var e = this._event(); return e && e.srcElement;};
  
  EVT_prototype.toElement = function(){var e = this._event(); return e && e.toElement;};
  
  EVT_prototype.fromElement = function(){var e = this._event(); return e && e.fromElement;};
  
  EVT_prototype.keyCode = function(){var e = this._event(); return e && e.keyCode;};
  
  EVT_prototype.clientX = function(){var e = this._event(); return e ? e.clientX : Number.NaN;};
  
  EVT_prototype.clientY = function(){var e = this._event(); return e ? e.clientY : Number.NaN;};
  
  EVT_prototype.getTrueX = function() {return this._event().screenX - window.screenLeft;};
  
  EVT_prototype.getTrueY = function() {return this._event().screenY - window.screenTop;};
  
  EVT_prototype.shiftKey = function(){var e = this._event(); return e && e.shiftKey;};
  
  EVT_prototype.ctrlKey = function(){var e = this._event(); return e && e.ctrlKey;};
  
  EVT_prototype.altKey = function(){var e = this._event(); return e && e.altKey;};
  
  EVT_prototype.enterKey = function(){return this._event().keyCode == 13;};
  
  EVT_prototype.spaceKey = function(){return this._event().keyCode == 32;};
  
  EVT_prototype.tabKey = function(){return this._event().keyCode == 9;};
  
  EVT_prototype.rightArrow = function(){return this._event().keyCode == 39;};
  
  EVT_prototype.leftArrow = function(){return this._event().keyCode == 37;};
  
  EVT_prototype.upArrow = function(){return this._event().keyCode == 38;};
  
  EVT_prototype.downArrow = function(){return this._event().keyCode == 40;};
  
  EVT_prototype.deleteKey = function(){return this._event().keyCode == 46;};
  
  EVT_prototype.backspaceKey = function(){return this._event().keyCode == 8;};
  
  EVT_prototype.insertKey = function(){return this._event().keyCode == 45;};
  
  EVT_prototype.homeKey = function(){return this._event().keyCode == 36;};
  
  EVT_prototype.endKey = function(){return this._event().keyCode == 35;};
  
  EVT_prototype.pageUpKey = function(){return this._event().keyCode == 33;};
  
  EVT_prototype.pageDownKey = function(){return this._event().keyCode == 34;};
  
  EVT_prototype.escapeKey = function(){return this._event().keyCode == 27;};
  
  EVT_prototype.exists = function(){return this._event() != null;};
  
  EVT_prototype.cancelBubble = function(){this._event().cancelBubble = true;};
  
  EVT_prototype.cancelReturn = function(){this._event().returnValue = false;};
  
  EVT_prototype.cancelKey = function(){this._event().keyCode = 0;};
  
  EVT_prototype.leftButton = function(){var e = this._event(); return e && e.button == 0;};
  
  EVT_prototype.rightButton = function(){var e = this._event(); return e && e.button == 2;};
  
  EVT_prototype.button = function(){var e = this._event(); return (e) ? e.button : null;};
  
  EVT_prototype.setReturn = function(RETURN){this._event().returnValue = RETURN;};
  
  EVT_prototype.setKeyCode = function(intKeyCode){this._event().keyCode = intKeyCode;};

  EVT_prototype.isModifierKey = function(){
    var e = this._event();
    return e.keyCode == 16 || e.keyCode == 17 || e.keyCode == 18;
  };

  EVT_prototype.toString = function() {
    var s = "";
    var e = this._event();
    if (e == null) return "jsx3.EVT <empty>";

    var fields = [];
    for (var f in e)
      fields.push(f);
    fields.sort();

    for (var i=0; i < fields.length; i++)
      s += fields[i] + ":" + e[fields[i]] + " ";

    return s;
  };

});


jsx3.EVENT = new jsx3.EVT();

//primitives; all on <properties> tag
jsx3.EVENT.MOUSEOVER = "onmouseover";
jsx3.EVENT.MOUSEOUT = "onmouseout";
jsx3.EVENT.MOUSEDOWN = "onmousedown";
jsx3.EVENT.MOUSEUP = "onmouseup";
jsx3.EVENT.MOUSEMOVE = "onmousemove";
jsx3.EVENT.CLICK = "onclick";
jsx3.EVENT.DOUBLECLICK = "ondblclick";
jsx3.EVENT.KEYPRESS = "onkeypress";
jsx3.EVENT.KEYUP = "onkeyup";
jsx3.EVENT.KEYDOWN = "onkeydown";
jsx3.EVENT.FOCUS = "onfocus";
jsx3.EVENT.ACTIVATE = "onactivate";
jsx3.EVENT.BLUR = "onblur";
jsx3.EVENT.SCROLL = "onscroll";
jsx3.EVENT.UNLOAD = "onunload";
jsx3.EVENT.BEFOREUNLOAD = "onbeforeunload";

//view events handled in model context as well as system events; all on <events> tag
jsx3.EVENT.JSXKEYUP = "jsxkeyup";
jsx3.EVENT.JSXKEYDOWN = "jsxkeydown";
jsx3.EVENT.JSXKEYUP = "jsxkeyup";
jsx3.EVENT.JSXKEYPRESS = "jsxkeypress";
jsx3.EVENT.JSXBLUR = "jsxblur";
jsx3.EVENT.JSXCLICK = "jsxclick";
jsx3.EVENT.JSXDOUBLECLICK = "jsxdblclick";
jsx3.EVENT.JSXMOUSEDOWN = "jsxmousedown";

jsx3.EVENT.SPYGLASS = "jsxspy";    //when the spyglass is about to show
jsx3.EVENT.DROP = "jsxdrop";      //after a drop event (one of: ondrop, canceldrop, beforedrop)
jsx3.EVENT.BEFOREDROP = "jsxbeforedrop";  //before a drop event (a mouseover)
jsx3.EVENT.CANCELDROP = "jsxcanceldrop";  //canceling a drop event (a mouseout)
jsx3.EVENT.CTRLDROP = "jsxctrldrop";    //after a ctrl drop event
jsx3.EVENT.DRAG = "jsxdrag";      //before a drag
jsx3.EVENT.ADOPT = "jsxadopt";     // when a record is adopted from this CDF object
jsx3.EVENT.SHOW = "jsxshow";      //when a menu or select or some other ephemeral VIEW element is about to be displayed
jsx3.EVENT.HIDE = "jsxhide";      //opposite of show
jsx3.EVENT.MENU = "jsxmenu";      //before a bound menu is shown
jsx3.EVENT.SELECT = "jsxselect";    //select, menu, tree, listview
jsx3.EVENT.TOGGLE = "jsxtoggle";    //treeview node open/close
jsx3.EVENT.EXECUTE = "jsxexecute";    //execute event as in a menu click or tree node click, or listview dbl-click; enter key; spacebar for button
jsx3.EVENT.BEFORERESIZE = "jsxbeforeresize";  //before a resize; typically a dialog or alert
jsx3.EVENT.AFTERRESIZE = "jsxafterresize";  //after resize; typically a dialog or alert
jsx3.EVENT.BEFOREMOVE = "jsxbeforemove";  //before a move event (fired by mouse down for any object that has been made "moveable")
jsx3.EVENT.AFTERMOVE = "jsxaftermove";  //after a move event
jsx3.EVENT.DESTROY = "jsxdestroy";    //when an object is removed from the JSX DOM
jsx3.EVENT.SORT = "jsxsort";      //NOT IMPLEMENTED: on a sort event
jsx3.EVENT.BEFORESORT = "jsxbeforesort";  //before a sort event
jsx3.EVENT.AFTERSORT = "jsxaftersort";  //after a sort event
jsx3.EVENT.PAINT = "jsxpaint";    //after repaint/insertHTML have been called
jsx3.EVENT.PAGE = "jsxpage";      //equivalent to 'onscroll'; superset category that also includes lazy fetch (paging) through large collections
jsx3.EVENT.INTERVAL = "jsxinterval";    //wraps "window.setInterval"; allows a timed event to fire every 'n' milliseconds; has a corresponding prop called 'jsxinterval' (interval)
jsx3.EVENT.DRAW = "jsxdraw";      //after 'redraw' has been called for a data client
jsx3.EVENT.DATA = "jsxdata";      //called when a data object (D.O.) has just acquired data; the D.O. will call this method to allow it to do any pre-processing or actual handling of the data
jsx3.EVENT.BEFOREEDIT = "jsxbeforeedit";       //called before showing an edit mask
jsx3.EVENT.AFTEREDIT = "jsxafteredit";         //called after showing an edit mask
jsx3.EVENT.CHANGE = "jsxchange";               //form value changed, tab changed
jsx3.EVENT.INCCHANGE = "jsxincchange";               //incremental change in text area, slider, etc
jsx3.EVENT.BEFOREAPPEND = "jsxbeforeappend";   //before a new CDF record and corresponding on-screen TR are added to a jsx3.gui.List instance or relevant subclass
jsx3.EVENT.AFTERAPPEND = "jsxafterappend";     //after a new CDF record and corresponding on-screen TR are added to a jsx3.gui.List instance or relevant subclass

 }


