


jsx3.Class.defineClass("jsx3.app.AddIn", null, [jsx3.net.URIResolver], function(AddIn, AddIn_prototype) {

  var URIResolver = jsx3.net.URIResolver;
  
  
  AddIn.PROTOTYPES_DIR = "prototypes/";

  
  AddIn_prototype.init = function(strKey) {
    
    this._key = strKey;
    
    this._path = strKey.indexOf("user:") == 0 ?  
                 jsx3.resolveURI("jsxuser:/addins/" + strKey.substring(5) + "/") :
                 jsx3.resolveURI(jsx3.ADDINSPATH + strKey + "/");
    
    this._uri = new jsx3.net.URI(this._path);
    
    this._uriabs = jsx3.app.Browser.getLocation().resolve(this._uri);
    
    this._settings = null;
  };
  
  
  AddIn_prototype.getId = function() {
    return this.getSettings().get("id");
  };
  
  
  AddIn_prototype.getName = function() {
    return this.getSettings().get("name");
  };
  
  
  AddIn_prototype.getDescription = function() {
    return this.getSettings().get("description");
  };
  
  
  AddIn_prototype.getVersion = function() {
    return this.getSettings().get("version");
  };
  
  
  AddIn_prototype.getJsxVersion = function() {
    return this.getSettings().get("jsxversion") || "3.1";
  };
  
  
  AddIn_prototype.getKey = function() {
    return this._key;
  };
  
  
  AddIn_prototype.getPath = function() {
    return this._path;
  };
  
  
  AddIn_prototype.getSettings = function() {
    if (this._settings == null) {
      var objXML = jsx3.getSystemCache().getOrOpenDocument(this._uri.resolve(jsx3.CONFIG_FILE), "JSX_SETTINGS::" + this.getKey());
      
      this._settings = new jsx3.app.Settings(objXML);
    }
    return this._settings;
  };
  
  AddIn_prototype.setSettings = function(objSettings) {
    this._settings = objSettings;
  };
  
  
  AddIn_prototype.resolveURI = function(strURI) {
    var uri = jsx3.net.URI.valueOf(strURI);
    
    if (jsx3.util.compareVersions(this.getJsxVersion(), "3.2") >= 0 && !URIResolver.isAbsoluteURI(uri))
      uri = this._uri.resolve(uri);

    return URIResolver.DEFAULT.resolveURI(uri);
  };
  
  
  AddIn_prototype.getUriPrefix = function() {
    return this._uri.toString();
  };    

  
  AddIn_prototype.relativizeURI = function(strURI, bRel) {
    var loc = jsx3.app.Browser.getLocation();
    var relative = this._uriabs.relativize(loc.resolve(strURI));

    if (relative.isAbsolute() || bRel)
      return relative;
    else
      return jsx3.net.URI.fromParts("jsxaddin", null, this.getKey().replace(/:/, "!"), null, 
          "/" + relative.getPath(), relative.getQuery(), relative.getFragment());
  };    

  
  AddIn_prototype.toString = function() {
    return this._key;
  };
  
  URIResolver.register("jsxaddin", function(uri) {
    var addinKey = uri.getHost().split("!", 2).join(":");
    return jsx3.System.getAddin(addinKey);
  });
  
});
