


jsx3.Class.defineClass("jsx3.app.DOM", null, [jsx3.util.EventDispatcher], function(DOM, DOM_prototype) {

  
  DOM._INC = {};

  
  DOM._LOOKUP = {};

  
  DOM._LOOKUP_REVERSE = {};

  
  DOM._LOOKUP_COUNT = 0;

  
  DOM.TYPEADD = 0;

  
  DOM.TYPEREMOVE = 1;

  
  DOM.TYPEREARRANGE = 2;

  
  DOM.EVENT_CHANGE = "change";

  
  DOM.newId = function(strNameSpace) {
    var nsKey = DOM._getNamespaceKey(strNameSpace);
    return "_jsx_" + nsKey + "_" + DOM._getNamespaceSerial(nsKey).toString(36);
  };

  
  DOM._getNamespaceKey = function(strNS) {
    if (DOM._LOOKUP[strNS] == null) {
      var key = (DOM._LOOKUP_COUNT++).toString(36);
      DOM._LOOKUP[strNS] = key;
      DOM._LOOKUP_REVERSE[key] = strNS;
    }

    return DOM._LOOKUP[strNS];
  };

  
  DOM._getNamespaceSerial = function(strNSKey) {
    if (DOM._INC[strNSKey] == null)
      DOM._INC[strNSKey] = 0;

    return ++DOM._INC[strNSKey];
  };

  
  DOM.getNamespaceForId = function(strId) {
    var key = strId.substring(5, strId.indexOf("_", 5));
    return DOM._LOOKUP_REVERSE[key];
  };

  
  DOM_prototype.init = function() {
    // holds index of of all GUI objects for this server instance, indexed via their system-assigned ID
    
    this.SYSTEMHASH = {};

    // holds index of all GUI objects for this server instance, indexed via the developer-assigned NAME
    
    this.USERHASH = {};
  };

  
  DOM_prototype.destroy = function() {
    delete this.SYSTEMHASH;
    delete this.USERHASH;
  };

  
  DOM_prototype.get = function(strId) {
    return this.SYSTEMHASH[strId] || this.getByName(strId);
  };

  
  DOM_prototype.getByName = function(strName) {
    var nameBucket = this.USERHASH[strName];
    return nameBucket != null ? nameBucket.get(0) : null;
  };

  
  DOM.EMPTY_LIST = [];

  
  DOM_prototype.getAllByName = function(strName) {
    var nameBucket = this.USERHASH[strName];
    return nameBucket != null ? nameBucket.toArray() : DOM.EMPTY_LIST;
  };

  
  DOM_prototype.getById = function(strId) {
    return this.SYSTEMHASH[strId];
  };

  
  DOM_prototype.add = function(objJSX) {
    this.SYSTEMHASH[objJSX.getId()] = objJSX;
    var name = objJSX.getName();
    if (name != null && name !== "") {
      if (this.USERHASH[name] == null)
        this.USERHASH[name] = jsx3.util.List.wrap([objJSX]);
      else
        this.USERHASH[name].add(objJSX, 0);
    }
  };

  
  DOM_prototype.remove = function(objJSX) {
    delete this.SYSTEMHASH[objJSX.getId()];

    var nameBucket = this.USERHASH[objJSX.getName()];
    if (nameBucket != null)
      nameBucket.remove(objJSX);
  };

  
  DOM_prototype.onNameChange = function(objJSX, oldName) {
    var oldBucket = this.USERHASH[oldName];
    if (oldBucket != null)
      oldBucket.remove(objJSX);

    var name = objJSX.getName();
    if (name != null && name !== "") {
      if (this.USERHASH[name] == null)
        this.USERHASH[name] = jsx3.util.List.wrap([objJSX]);
      else
        this.USERHASH[name].add(objJSX, 0);
    }
  };

  
  DOM_prototype.onChange = function(TYPE, JSXPARENTID, JSXID) {
    this.publish({subject:DOM.EVENT_CHANGE, type:TYPE, parentId:JSXPARENTID, jsxId:JSXID});
  };

});




jsx3.DOM = jsx3.app.DOM;


