// @jsxobf-clobber-shared  _jsxevents _jsxtempdynamic _jsxdynamic _jsxloading _applyId

jsx3.Class.defineClass("jsx3.app.Model", null, [jsx3.util.EventDispatcher], function(Model, Model_prototype) {

  var Entity = jsx3.xml.Entity;
  var Document = jsx3.xml.Document;

  Model.PERSISTNONE = 0;

  Model.PERSISTEMBED = 1;

  Model.PERSISTREF = 2;

  Model.PERSISTREFASYNC = 3;

  Model.LT_NORMAL = 0;

  Model.LT_SLEEP_PAINT = 1;

  Model.LT_SLEEP_DESER = 2;

  Model.LT_SLEEP_PD = 3;

  Model.LT_SHOW_PAINT = 4;

  Model.LT_SHOW_DESER = 5;

  Model.CURRENT_VERSION = "urn:tibco.com/v3.0";

  Model.CIF_VERSION =  "http://xsd.tns.tibco.com/gi/cif/2006";

  Model.FRAGMENTNS = "JSXFRAG";

  Model.ASYNC_LOAD_TIMEOUT = 60000;

  Model._CIFPROCESSORURL = jsx3.resolveURI("jsx:///xsl/cif_resolver.xsl");

  // TODO: eventually it would be nice to be able to clobber all of the following

  Model_prototype._jsxid = null;

  Model_prototype._jsxparent = null;

  Model_prototype._jsxchildren = null;

  Model_prototype._jsxns = null;

  Model_prototype._jsxserver = null;

  Model_prototype._jsxfragment = null;

  Model_prototype._jsxpersistence = null;

  Model_prototype._jsxmeta = null;

  Model_prototype._jsxshowstate = true;

  Model_prototype.init = function(strName, strInstanceOf) {
    //call constructor for super class just in case a global mod needs to be communicated on down from the top-most jsx class, inheritance
    this.jsxsuper();

    //initialize and define common properties shared by all subclasses of jsx3.app.Model

    // DEPRECATED: remove strInstanceOf parameter and references
    this.jsxinstanceof = (strInstanceOf == null) ? "jsx3.app.Model" : strInstanceOf;

    this.jsxname = strName;
  };

  Model_prototype.getChild = function(vntIndexOrName) {
    var intIndex = null;

    if (this._jsxchildren != null) {
      if (typeof(vntIndexOrName) == "string" || isNaN(vntIndexOrName)) {
        var index = -1;
        var childArray = this.getChildren();
        var maxLen = childArray.length;
        for (var i = 0; i < maxLen; i++) {
          if (vntIndexOrName == childArray[i].getName()) {
            intIndex = i;
            break;
          }
        }
      } else {
        //calling function passed an index (integer), so just set to local variable
        intIndex = vntIndexOrName;
      }

      if (intIndex >= 0 && intIndex < this._jsxchildren.length)
        return this._jsxchildren[intIndex];
    }

    return null;
  };

  Model_prototype.getFirstChild = function() {
    return this.getChild(0);
  };

  Model_prototype.getLastChild = function() {
    return this.getChild(this.getChildren().length-1);
  };

  Model_prototype.getNextSibling = function() {
    if (! this._jsxparent) return null;
    return this._jsxparent.getChild(this.getChildIndex() + 1);
  };

  Model_prototype.getPreviousSibling = function() {
    if (! this._jsxparent) return null;
    return this._jsxparent.getChild(this.getChildIndex() - 1);
  };

  Model_prototype.getChildren = function() {
    if (this._jsxchildren == null) this._jsxchildren = [];
    return this._jsxchildren;
  };

  Model_prototype.getPersistence = function() {
    return this._jsxpersistence;
  };

  Model_prototype.getPersistenceUrl = function() {
    return this.getMetaValue("url");
  };

  Model_prototype.setPersistence = function(intPersist) {
    this._jsxpersistence = intPersist;
    return this;
  };

  Model_prototype.setChild = function __Model_prototype_setChild(objChild, intPersist, strSourceURL, strNS) {
    //find out the server that will own this object instance
    var bFragment = false;
    if (strNS == null && this._jsxns == null) {
      strNS = Model.FRAGMENTNS;
    } else if (strNS != null) {
      bFragment = true;
    } else {
      strNS = this._jsxns;
    }

    var objServer = this.getServer();

    //only add this item to a server instance if not part of the 'fragment' ns
    if (strNS != Model.FRAGMENTNS && objServer && this._jsxns == strNS) {
      //all items are fragments until added to a valid DOM.  Some fragments already have nested descendants that also need to be bound and registered
      this._bindFragment(objChild, strNS, objChild._jsxfragment != null, objServer);
    } else {
      //the parent ('this') does not yet belong to a DOM (its a fragment); set a flag that lets us know, so when it is finally added to a DOM, its descendant _jsxns props are updated and name/id are applied
      this._jsxfragment = 1;
    }

    //create an array to hold child if not yet created
    var children = this._jsxchildren;
    if (!children) children = this._jsxchildren = [];

    //increment the array and reference the new object
    children[children.length] = objChild;
    objChild._jsxparent = this;

    //set persistent type and urls if applicable
    if (intPersist == null) intPersist = Model.PERSISTNONE;
    objChild._jsxpersistence = intPersist;
    if (strSourceURL && (intPersist == Model.PERSISTREF || intPersist == Model.PERSISTREFASYNC))
      objChild.setMetaValue("url", strSourceURL.toString());

    //issue a DOM onChange call to reflect the update; pass the id of this object as well as the newly-added child;
    if (!bFragment && strNS != Model.FRAGMENTNS)
      objServer.getDOM().onChange(jsx3.app.DOM.TYPEADD, this.getId(), objChild.getId());

    return this;
  };

  Model_prototype.onSetChild = function(objChild) {
    return true;
  };

  Model_prototype.onSetParent = function(objParent) {
    return true;
  };

  Model_prototype.onRemoveChild = function(objChild, intIndex) {
  };

  Model_prototype.onChildAdded = function(objChild) {
  };

  //TODO: need method in model independent of how items are painted--otherwise the DOM is worthless without a view
  Model_prototype.hasPaintProfile = function() {
    //no-op; used by the new model
    return false;
  };

  Model_prototype._bindFragment = function(objChild, strNS, bDeep, objServer) {
    //update the namespace property for the child to match that of the parent objChild._jsxns = strNS;
    objChild._jsxns = strNS;
    objChild._applyId(strNS);

    //assign the system Id to @objChild and add a pointer to @objChild to the systemhash
    objServer.getDOM().add(objChild);

    //recurse through descendant of @objChild if @objChild is a 'deep' fragment -- one with descendants
    if (bDeep) {
      //remove the fragment flag, since now a valid DOM object
      delete objChild._jsxfragment;
      //iterate through descendants
      var objKids = objChild.getChildren();
      var maxLen = objKids.length;
      for (var i = 0; i < maxLen; i++)
        objChild._bindFragment(objKids[i], strNS, true, objServer);
    }
  };

  Model_prototype._applyId = function(strNS) {
    this._jsxid = jsx3.app.DOM.newId(strNS);
  };

  Model_prototype.removeChild = function(vntItem) {





















  };

  Model_prototype._removeChildRecurse = function(intIndex, objServer, bAll) {































  };

  Model_prototype.removeChildren = function(arrChildren) {





























  };

  Model_prototype.getServer = function() {
    var node = this;
    while (node) {
      if (node._jsxserver) return node._jsxserver;
      node = node._jsxparent;
    }
    return null;
  };

  Model_prototype._getLocale = function() {
    var objServer = this.getServer();
    return objServer != null ? objServer.getLocale() : jsx3.System.getLocale();
  };

  Model_prototype._getLocaleProp = function(strProp) {
    return jsx3.System.getLocaleProperties(this._getLocale()).get(strProp);
  };

  Model_prototype.adoptChild = function(objChild, bRepaint, bForce) {
    this._adoptChild(objChild.getChildIndex(), objChild, bRepaint, bForce, false);
  };

  Model_prototype.adoptChildrenFrom = function(objParent, arrChildren, bRepaint, bForce) {
    if (!arrChildren) arrChildren = objParent.getChildren().concat();
    if (arrChildren.length > 0) {
      for (var i = 0; i < arrChildren.length; i++)
        this._adoptChild(arrChildren[i].getChildIndex(), arrChildren[i], bRepaint, bForce, true);
      objParent.onRemoveChild(arrChildren, null);
      for (var i = 0; i < arrChildren.length; i++)
        this.onChildAdded(arrChildren[i]);
    }
  };

  Model_prototype._insertBefore = function(intMoveIndex,intPrecedeIndex) {
    //exit early if the move wouldn't occur
    if(intMoveIndex == intPrecedeIndex || intMoveIndex == intPrecedeIndex-1) return false;

    //reassemble the child array
    var objChildren = this.getChildren();
    var intAdjustedP = (intMoveIndex < intPrecedeIndex) ? intPrecedeIndex - 1 : intPrecedeIndex;
    var objMove = objChildren.splice(intMoveIndex, 1);
    var objStart = objChildren.splice(0, intAdjustedP);
    this._jsxchildren = objStart.concat(objMove,objChildren);

    this.onChildAdded(objMove[0]);
    //fire the DOM onchange event since we affected the MODEL directly
    this.getServer().getDOM().onChange(jsx3.app.DOM.TYPEREARRANGE,this.getId(),intPrecedeIndex);

    return true;
  };

  Model_prototype.insertBefore = function(objMoveChild,objPrecedeChild,bRepaint) {
    //adopt first if not common parent
    var bSuccess = true;
    if (!objMoveChild._jsxparent || !objPrecedeChild) {
      //user is inserting a fragment
      bSuccess = this.setChild(objMoveChild);
    } else if(objMoveChild._jsxparent != this) {
      //user is adopting
      bSuccess = this._adoptChild(objMoveChild.getChildIndex(),objMoveChild,false,true,true);
    }

    if (bSuccess) {
      //now do the reorder
      if (objPrecedeChild)
        bSuccess = this._insertBefore(objMoveChild.getChildIndex(), objPrecedeChild.getChildIndex());

      //check for suppress and return
      if (bRepaint !== false)
        this.repaint();
    }

    return bSuccess;
  };

  Model_prototype._adoptChild = function(intIndex, objChild, bRepaint, bForce, bMulti) {
    //make sure the adoption is allowed
    if (bForce) {
      this.onSetChild(objChild);
      objChild.onSetParent(this);
    } else {
      if (!this.onSetChild(objChild) || !objChild.onSetParent(this))
        return false;
    }

    //(1) get handle to parent, since we're about to lose the ref
    var objParent = objChild._jsxparent;

// JCG: I don't think that this is necessary ... was causing box model reconstruction before the adoption
//    //destroy the box profile. the new parent will determine it (this is a MODEL method for the Box profile)
//    objChild.recalc();

    //(2) remove circular reference from child (objChild) to the former parent(this)
    delete objChild._jsxparent;

    //(2b) remove box profile (allow it to be reconstructed in context of the new parent)
    objChild.clearBoxProfile(true);

    //(3) restack the former parent's child array to remove a reference to the now-obsolete item
    if (objParent._jsxchildren != null) objParent._jsxchildren.splice(intIndex, 1);

    //(4) destroy the existing view for the child (the user has no choice in this; they can choose to not paint the new, but the old has to be removed)
    objChild.destroyView(objParent);

    // send old parent onRemove message
    if (! bMulti)
      objParent.onRemoveChild(objChild, intIndex);

    //persist ref to servers involved
    var curServer = objParent.getServer();
    var newServer = this.getServer();
    var bServerChange = curServer != newServer;

    //(5) call recursive fn for child if the new parent belongs to a different server (they can't access the cache where they once stored their data, etc, and other server-specific resources that may no longer be accessible)

    if (bServerChange)
      this._adoptChildRecurse(objChild, objParent, curServer, newServer);

    //fire the onChange for the old server (we just removed a child)
    curServer.getDOM().onChange(jsx3.app.DOM.TYPEREMOVE, objParent.getId(), objChild.getId());

    //INSERT OBJCHILD INTO THE CHILD ARRAY FOR THE NEW PARENT
    var children = this._jsxchildren;
    if (!children) children = this._jsxchildren = [];
    children[children.length] = objChild;
    objChild._jsxparent = this;

    if (! bMulti)
      this.onChildAdded(objChild);

    //update the VIEW immediately to match the model unless explicitly told to wait
    if (bRepaint !== false) this.viewUpdateHook(objChild, bMulti && objParent._jsxchildren.length > 0);

    //fire the onChange for the new server (we just added a child)
    newServer.getDOM().onChange(jsx3.app.DOM.TYPEADD, this.getId(), objChild.getId());

    //return a handle to this
    return this;
  };

  Model_prototype.viewUpdateHook = function(objChild, bGroup) {
  };

  Model_prototype.destroyView = function(objParent) {
    var objGUI = objParent.getServer().getRenderedOf(this);
    if (objGUI)
      jsx3.html.removeNode(objGUI);
  };

  Model_prototype._adoptChildRecurse = function(objChild, objFormerParent, curServer, newServer) {
    //dereference the object by removing it from the global arrays that point to the object
    curServer.getDOM().remove(objChild);
    // reset the child's server namespace
    objChild._jsxns = this._jsxns;
    // insert pointers into the new server's hash to ref the child
    newServer.getDOM().add(objChild);

    objChild.onChangeServer(newServer, curServer);

    var children = objChild.getChildren();
    for (var i = 0; i < children.length; i++)
      objChild._adoptChildRecurse(children[i], null, curServer, newServer);
  };

  Model_prototype.onChangeServer = function(objNewServer, objOldServer) {
  };

  Model_prototype.doClone = function(intPersist, intMode) {
    var objLoadInto = intMode == 2 ? this.getServer().getRootBlock() : this._jsxparent;

    if (objLoadInto) {
      // Clone by serializing to XML and then deserializing, which ensures only valid structures get cloned
      var objJSXClone = objLoadInto._loadObject(
          this.toXMLDoc(), intMode < 1, intPersist, null, null, intMode == 2 ? Model.FRAGMENTNS : null);
      return objJSXClone ? objJSXClone[0] : null;
    } else {
      throw new jsx3.Exception(jsx3._msg("model.clone_frag", this));
    }
  };

  Model_prototype.getDescendantOfName = function(strName, bDepthFirst, bChildOnly) {
    return this.findDescendants(function(x){ return x.getName() == strName; },
        bDepthFirst, false, bChildOnly, false);
  };

  Model_prototype.getFirstChildOfType = function(strType, bExact) {
    if (bExact) {
      var objClass = null;
      if (typeof(strType) == "string") objClass = jsx3.Class.forName(strType);
      else if (typeof(strType) == "function" && strType.jsxclass instanceof jsx3.Class) objClass = strType.jsxclass;
      else if (strType instanceof jsx3.Class) objClass = strType;

      return this.findDescendants(function(x){ return x.getClass().equals(objClass); },
          false, false, true, false);
    } else {
      return this.findDescendants(function(x){ return x.instanceOf(strType); },
          false, false, true, false);
    }
  };

  Model_prototype.getDescendantsOfType = function(strType, bShallow) {
    return this.findDescendants(function(x){ return x.instanceOf(strType); },
        false, true, bShallow, false);
  };

  Model_prototype.findDescendants = function(fctTest, bDepthFirst, bMultiple, bShallow, bIncludeSelf) {
    var fctPush = bDepthFirst ? 'unshift' : 'push';
    var matches = bMultiple ? [] : null;
    var list = bIncludeSelf ? [this] : this.getChildren().concat();

    while (list.length > 0) {
      var node = list.shift();

      if (fctTest.call(null, node)) {
        if (bMultiple)
          matches[matches.length] = node;
        else
          return node;
      }

      if (! bShallow)
        list[fctPush].apply(list, node.getChildren());
    }

    return matches;
  };

  Model_prototype.onDestroy = function(objParent) {
    // This method should be overridden by classes with an on-screen view represented by a TD object.
    //always remove the on-screen instance for this object (assuming it's been painted already)
  };

  Model_prototype.getId = function() {
    return this._jsxid;
  };

  Model_prototype.getChildIndex = function() {
    var objParent = this._jsxparent;
    if (objParent != null)
      return jsx3.util.arrIndexOf(objParent.getChildren(), this);
    return -1;
  };

  Model_prototype.getName = function() {
    return this.jsxname;
  };

  Model_prototype.setName = function(strName) {
    if (strName != null) {
      // update name and add object reference via new name
      var oldName = this.jsxname;
      this.jsxname = strName;

      var objServer = this.getServer();
      if (objServer) objServer.getDOM().onNameChange(this, oldName);
    }
    return this;
  };

  Model_prototype.getHelpId = function() {
    return this.jsxhelpid;
  };

  Model_prototype.setHelpId = function(strId) {
    this.jsxhelpid = strId;
  };

  Model_prototype.getLoadType = function() {
    return this.jsxloadtype || Model.LT_NORMAL;
  };

  Model_prototype.setLoadType = function(intLoadType) {
    this.jsxloadtype = intLoadType;
  };

  Model_prototype._getShowState = function() {
    return this._jsxshowstate;
  };

  Model_prototype._setShowState = function(bShow) {
    if (this._jsxshowstate != bShow) {
      this._jsxshowstate = bShow;
      if (bShow) {
        var objGUI = this.getRendered();
        //3.6: added the following to repaint the domholder object if it is in fact the domholder (don't just check content existence)
        if (objGUI && (!objGUI.firstChild || objGUI.getAttribute("jsxdomholder") == "1"))
          this.repaint();
      }
    }
  };

  Model_prototype.getParent = function() {
    return this._jsxparent;
  };

   Model_prototype.getAncestorOfType = function(strType) {
     return this.findAncestor(function(x){ return x.instanceOf(strType); }, false);
   };

   Model_prototype.getAncestorOfName = function(strName) {
     return this.findAncestor(function(x){ return x.getName() == strName; }, false);
   };

  Model_prototype.findAncestor = function(fctTest, bIncludeSelf) {
    var parent = bIncludeSelf ? this : this._jsxparent;
    while (parent != null) {
      if (fctTest.call(null, parent))
        return parent;
      parent = parent._jsxparent;
    }
    return null;
  };

  Model_prototype.toXML = function(objProperties) {
    return this.toXMLDoc(objProperties).serialize(true, objProperties != null ? objProperties.charset : null);
  };

  Model_prototype.toXMLDoc = function(objProperties) {
    if (objProperties == null) {
      objProperties = this._jsxmeta;
      if (objProperties == null) objProperties = {};
    } else {
      if (this._jsxmeta != null) {
        objProperties = jsx3.clone(objProperties);
        for (var f in this._jsxmeta) {
          if (typeof(objProperties[f]) == "undefined")
            objProperties[f] = this._jsxmeta[f];
        }
      }
    }

    var ns = Model.CURRENT_VERSION;
    var objXML = new jsx3.xml.Document();
    var objRoot = objXML.createDocumentElement("serialization", ns);
    objRoot.setAttribute("jsxversion", Model._getComponentAuthorVersion());

    for (var f in Model._META_MAP) {
      if (typeof(objProperties[f]) != "undefined") {
        var nodeName = Model._META_MAP[f];
        var elem = objXML.createNode(Entity.TYPEELEMENT, nodeName, ns);
        elem.appendChild(objXML.createNode(Entity.TYPECDATA, objProperties[f], ns));
        objRoot.appendChild(elem);
      }
    }

    if (objProperties.children) {
      var maxLen = this.getChildren().length;
      for (var i = 0; i < maxLen; i++) {
        objRoot.appendChild(this.getChild(i)._doSerialize(objXML, objProperties));
      }
    } else {
      objRoot.appendChild(this._doSerialize(objXML, objProperties));
    }

    return objXML;
  };

  Model._getComponentAuthorVersion = function() {
    var tokens = jsx3.System.getVersion().split(".");
    return tokens[0] + "." + tokens[1];
  };

  Model._OBJ_ARRAYS =
      {_jsxdynamic:"dynamics", jsxcustom:"properties", _jsxevents:"events", jsxxslparams:"xslparameters"};

  Model._boolnumber = {"boolean":1, "number":1};

  Model_prototype._doSerialize = function(objXML, objProperties) {
    // create <object>
    var ns = Model.CURRENT_VERSION;
    var objNode = objXML.createNode(Entity.TYPEELEMENT, "object", ns);

    // set the object type
    var objClass = this.getClass();
    var strType = objClass != null ? objClass.getName() : null;

    // DEPRECATED: should eventually only consult getClass()
    if (strType == null)
      strType = this.jsxinstanceof;

    objNode.setAttribute("type", strType);

    // declare variable to persist string and number/booleam properties
    var objVars = objXML.createNode(Entity.TYPEELEMENT, "variants", ns);
    var objStrings = objXML.createNode(Entity.TYPEELEMENT, "strings", ns);
    objNode.appendChild(objVars);
    objNode.appendChild(objStrings);

    // serialize events, dynamic properties, and attributes
    for (var f in Model._OBJ_ARRAYS) {
      var a = this[f];
      if (a != null && typeof(a) == "object") {
        var objDynNode = Model._serializeObjectArray(objXML, Model._OBJ_ARRAYS[f], a);
        if (objDynNode != null) {
          objNode.appendChild(objDynNode);
          //3.7: added the following to remove any temporary dynamic properties
          if(Model._OBJ_ARRAYS[f] == "dynamics" && this._jsxtempdynamic)
            for(var p in this._jsxtempdynamic)
              objDynNode.removeAttribute(p);
        }
      }
    }

    // serialize the children
    var children = this._jsxchildren;
    if (children) {
      if (children instanceof Array) {
        var numChildren = children.length;
        if (numChildren > 0) {
          for (var i = 0; i < numChildren; i++) {
            //recurse through descendants
            var child = children[i];
            var intPersist = child._jsxpersistence;

            if (intPersist == Model.PERSISTREF || intPersist == Model.PERSISTREFASYNC) {
              if (intPersist == Model.PERSISTREFASYNC && (i != numChildren-1)) {
                jsx3.util.Logger.GLOBAL.warn(jsx3._msg("model.async_convt", this));
                intPersist = child._jsxpersistence = Model.PERSISTREF;
              }

              var objInclude = objXML.createNode(Entity.TYPEELEMENT, "include", ns);
              objInclude.setAttribute("src", child.getPersistenceUrl());
              objInclude.setAttribute("async", intPersist == Model.PERSISTREFASYNC ? "true" : "false");
              objNode.appendChild(objInclude);
            } else if (intPersist == Model.PERSISTEMBED || objProperties.persistall) {
              objNode.appendChild(child._doSerialize(objXML, objProperties));
            }
          }
        }
      } else {
        jsx3.util.Logger.GLOBAL.error(jsx3._msg("model.child_notarr", this, this[p]));
      }
    }

    // NOTE: this is pretty slow in IE6, since jsx3.gui.Block has >250 fields to iterate over
    // serialize all arrays, string, boolean, and number properties
    for (var p in this) {
      var val = this[p];
      var type = typeof(val);

      // only act upon properties/attributes of the object, not its functions
      if (type == "function" || p.indexOf("_jsx") == 0 || val == null) {
        ;
      } else if (val instanceof Array) {
        var asString = new Array(val.length);
        for (var i = 0; i < val.length; i++) {
          var aval = val[i];
          asString[i] = Model._boolnumber[typeof(aval)] ? aval : "'" + aval + "'";
        }
        objVars.setAttribute(p, "[" + asString.join(",") + "]");
      } else if (type == "object") {
        ;
      } else {
        if (this._jsxdynamic == null || this._jsxdynamic[p] == null) {
          //ensure that this property gets evaluated during deserialization if it is a number or boolean
          if (Model._boolnumber[type]) {
            objVars.setAttribute(p, String(val));
          } else {
            objStrings.setAttribute(p, val);
          }
        }
      }
    }

    return objNode;
  };

  Model._serializeObjectArray = function(objXML, strTagName, objArray) {
    var objNode = null;
    for (var f in objArray) {
      if (objNode == null)
        objNode = objXML.createNode(Entity.TYPEELEMENT, strTagName, Model.CURRENT_VERSION);
      objNode.setAttribute(f, String(objArray[f]));
    }
    return objNode;
  };

  Model_prototype.getNS = function() {
    return this._jsxns;
  };

  Model_prototype.getUriResolver = function() {
    var node = this;
    while (node != null) {
      if (node._jsxloadcontext && node._jsxloadcontext.resolver) return node._jsxloadcontext.resolver;
      if (node._jsxserver != null) return node._jsxserver;
      node = node._jsxparent;
    }
    return null;
  };

  Model_prototype.load = function(strURL, bRepaint, objResolver) {
    //parse xml and pass to common handler
    var rsURL = (objResolver || this.getUriResolver()).resolveURI(strURL);
    var objXML = (new Document()).load(rsURL);

    if (objXML.hasError())
      throw new jsx3.Exception(jsx3._msg("model.bad_comp", rsURL, objXML.getError()));

    return this._loadObject(objXML, bRepaint, null, rsURL, strURL, null, null, objResolver, null)[0];
  };

  Model_prototype.loadXML = function(strXML, bRepaint, objResolver) {
    //parse xml and pass to common handler
    var objXML = strXML instanceof Document ? strXML : (new Document()).loadXML(strXML);

    if (objXML.hasError()) {
      var strSourceURL = objXML.getSourceURL();
      var msgId = strSourceURL ? "model.bad_comp" : "model.bad_compobj";
      throw new jsx3.Exception(jsx3._msg(msgId, strSourceURL, objXML.getError()));
    }

    return this._loadObject(objXML, bRepaint, null, objXML.getSourceURL(), objXML.getSourceURL(), null, null, objResolver, null)[0];
  };

  Model_prototype.loadAndCache = function(strURL, bRepaint, objCache, objResolver) {
    if (objCache == null) objCache = this.getServer().getCache();
    var rsURL = (objResolver || this.getUriResolver()).resolveURI(strURL);
    var objXML = objCache.getOrOpenDocument(rsURL);

    if (objXML.hasError())
      throw new jsx3.Exception(jsx3._msg("model.bad_comp", rsURL, objXML.getError()));

    return this._loadObject(objXML, bRepaint, null, rsURL, strURL, null, objCache, objResolver, null)[0];
  };

  Model._formatCIF = function(objXML) {
    jsx3.require("jsx3.xml.Template");
    var doc = jsx3.getSystemCache().getOrOpenDocument(Model._CIFPROCESSORURL, null, jsx3.xml.XslDocument.jsxclass);
    return doc.transformToObject(objXML);
  };

  Model._META_MAP = {name:"name", icon:"icon", description:"description", onbefore:"onBeforeDeserialize",
    onafter:"onAfterDeserialize"};

  Model_prototype._loadObject = function(objXML, bRepaint, intPersist, strSourceURL, strRawURL, strNS,
                                        objCache, objResolver, objServer) {

    if (! objServer || intPersist == Model.PERSISTREFASYNC)
      var t1 = new jsx3.util.Timer(Model.jsxclass, strSourceURL);

    if (objXML == null)
      throw new jsx3.IllegalArgumentException("objXML", objXML);

    // determine which deserialization routine to use based upon the xmlns attribute for the serialization file
    if (objXML.getRootNode().getNamespaceURI().indexOf(Model.CIF_VERSION) == 0) {

      //convert the CIF document format (Model.CIF_VERSION) to the standard serializer (Model.CURRENT_VERSION)
      objXML = Model._formatCIF(objXML);

      //throw error if xml is now invalid
      if (objXML == null)
        throw new jsx3.IllegalArgumentException("objXML", objXML);
    }

    // determine which deserialization routine to use based upon the xmlns attribute for the serialization file
    if (objXML.getRootNode().getNamespaceURI().indexOf(Model.CURRENT_VERSION) != 0) {
      throw new jsx3.Exception(jsx3._msg("model.bad_vers", strSourceURL, objXML.getRootNode().getAttribute("xmlns")));
    } else {
      var v = objXML.getRootNode().getAttribute("jsxversion");
      if (v && jsx3.util.compareVersions(v, jsx3.System.getVersion()) > 0)
        throw new jsx3.Exception(jsx3._msg("model.future_vers", strSourceURL, v));
    }

    var bFragment = strNS == Model.FRAGMENTNS;
    var serPath = "/jsx1:serialization/";

    objXML.setSelectionNamespaces("xmlns:jsx1='" + Model.CURRENT_VERSION + "'");
    var strOnBeforeDeserializeNode = objXML.selectSingleNode(serPath + "jsx1:onBeforeDeserialize");
    if (strOnBeforeDeserializeNode != null) {
      var strOnBeforeDeserialize = strOnBeforeDeserializeNode.getValue();
      if (strOnBeforeDeserialize && !objXML._jsxdidbeforedsrlz) {
        try {
          jsx3.eval(strOnBeforeDeserialize, {objPARENT:this, objXML:objXML});

          objXML._jsxdidbeforedsrlz = true;
        } catch (e) {
          jsx3.util.Logger.GLOBAL.error(jsx3._msg("model.onbefore", strSourceURL), jsx3.NativeError.wrap(e));
        }
      }
    }

    //derive the namespace that should be used (infer if not explicitly passed)
    if (strNS == null) strNS = this._jsxns;

    var previousResolver = this.getUriResolver() || objServer;

    if (objResolver == null) {
      // if the resolver is not explicitly provided and the raw URI implies a resolver, we need to store that
      // resolver at this point in the DOM
      objResolver = jsx3.net.URIResolver.getResolver(strRawURL);
    } else if (strRawURL) {
      if (objResolver.getUriPrefix() != previousResolver.getUriPrefix()) {
        // if the resolver is provided and the raw URI is relative to that resolver, we need to store the absolute
        // URI relative to that resolver.
        strRawURL = jsx3.net.URI.valueOf(strRawURL);
        if (! jsx3.net.URIResolver.isAbsoluteURI(strRawURL))
          strRawURL = objResolver.relativizeURI(strRawURL);
      }
    }

    var attachedServer = this.getServer();

    // this resolver will be used for any includes found from this point down
    if (objServer == null)
      objServer = attachedServer;
    var branchResolver = objResolver || previousResolver;

    //deserialize and bind new component as a child this instance
    var i = objXML.selectNodeIterator(serPath + "jsx1:object | " + serPath + "jsx1:objects/jsx1:object | /jsx1:object");
    var objToInsert = [];

    var loadContext = {uri:strSourceURL, resolver:objResolver, nameIndex:{}, varNameIndex:{}};

    while (i.hasNext()) {
      //get node descriptor in the XML serializatoin file and deserialize the node as a child of 'this' object
      var objNode = i.next();
      var objJSX = this._doLoad(objNode, strSourceURL, strNS, objServer, objCache, branchResolver, loadContext);

      //if a valid child resulted (was the serialzation file valid and the referenced GUI object type a valid class?)
      if (objJSX != null) {
        //this item is a valid JSX GUI object will be added as a child to the MODEL; track it so it can auto-inserted (as DHTML) into the VIEW
        objToInsert[objToInsert.length] = objJSX;

        //set the current child
        if (!bFragment)
          var success = this.setChild(objJSX, intPersist, strSourceURL, strNS);
        if (success === false) return false;

        //profile the current child with information about where it came from
        if (objToInsert.length == 1) {
          if (strRawURL)
            objJSX.setMetaValue("url", strRawURL.toString());
          for (var f in Model._META_MAP) {
            var node = objXML.selectSingleNode(serPath + "jsx1:" + Model._META_MAP[f]);
            if (node != null)
              objJSX.setMetaValue(f, node.getValue());
          }
        }

        if (attachedServer != null)
          objJSX.onAfterAttach();
      }
    }

    //fire the onChange event for the dom controller managing this server (setChild would have fired this, but due to fragment ns this is the safer method)
    if (!bFragment && objToInsert.length > 0 && attachedServer)
      attachedServer.getDOM().onChange(jsx3.app.DOM.TYPEADD, this.getId(), objToInsert[0].getId());

    if (t1) t1.log("load", true);

    //update the view by iterating through all GUI objects that were just added to the model by adding their DHTML directly into the view
    if (bRepaint !== false) {
      for (var j = 0; j < objToInsert.length; j++)
        this.viewUpdateHook(objToInsert[j], j < objToInsert.length - 1);

      if (t1) t1.log("paint");

    }

    //return handle to last item deserialized
    return objToInsert;
  };

  Model.META_FIELDS = {url: 1, name: 1, icon: 1, description: 1, onafter: 1, onattach: 1, onbefore: 1, unicode: 1};

  Model_prototype.getMetaValue = function(strKey) {
    if (Model.META_FIELDS[strKey])
      return this._jsxmeta ? this._jsxmeta[strKey] : "";
    else
      throw new jsx3.IllegalArgumentException("strKey", strKey);
  };

  Model_prototype.setMetaValue = function(strKey, strValue) {
    if (Model.META_FIELDS[strKey]) {
      if (this._jsxmeta == null) this._jsxmeta = {};
      this._jsxmeta[strKey] = strValue;
    } else {
      throw new jsx3.IllegalArgumentException("strKey", strKey);
    }
  };

  Model_prototype._doLoad = function(objXML, strSourceURL, strNS, objServer, objCache, objResolver, loadContext) {
    if (objXML == null) return null;

    // Check the load type
    if (! objXML._jsxloading) {
      var loadType = objXML.selectSingleNode("jsx1:variants/@jsxloadtype");
      loadType = loadType ? parseInt(loadType.getValue()) : Model.LT_NORMAL;
      if (loadType == Model.LT_SLEEP_DESER || loadType == Model.LT_SLEEP_PD || loadType == Model.LT_SHOW_DESER) {
        jsx3.require("jsx3.gui.Painted"); // this class defines jsx3.app.Model.Loading
        var objInstance = new Model.Loading(objXML, loadType, [strSourceURL, strNS, objServer, objCache, objResolver, loadContext]);
        objInstance._jsxns = strNS;
        return objInstance;
      }
    }

    //get the JSX foundation class that the object will be an instance of
    var strType = objXML.getAttribute("type");
    var objClass = jsx3.Class.forName(strType);

    // DEPRECATED: check for un-registered class
    if (objClass == null)
      objClass = jsx3.getClass(strType);

    // support for loading classes as needed
    if (objClass == null) {
      try {
        objClass = jsx3.CLASS_LOADER.loadClass(strType);
      } catch (e) {
        jsx3.util.Logger.GLOBAL.error(jsx3._msg("model.load_cls", strType), jsx3.NativeError.wrap(e));
      }
    }

    //log error if the class isn't supported
    if (objClass == null) {
      //errors occur if class definition file doesn't exist for the object
      jsx3.util.Logger.GLOBAL.error(jsx3._msg("model.bad_type", strSourceURL, strType));
      return null;
    }

    //create the object instance of the given class and set its 'jsxtype' property
    var objInstance = null;
    if (objClass instanceof jsx3.Class) {
      objInstance = objClass.bless();
    } else {

      // DEPRECATED: old style instantiation
      objInstance = new objClass(jsx3.DESERIALIZE);
      objInstance.jsxinstanceof = strType;

    }

    // attach the URI resolver to this DOM node

    objInstance._jsxloadcontext = loadContext;

    objInstance._jsxns = strNS;
    objInstance.onBeforeAssemble(this, objServer);

    //call functions that will extract variant, dynamic, and string data types and apply to the object instance
    for (var i = objXML.selectNodeIterator("jsx1:strings | jsx1:variants | jsx1:dynamics | jsx1:properties | jsx1:events | jsx1:xslparameters"); i.hasNext(); ) {
      var n = i.next();
      var name = n.getBaseName();
      if (name == "strings")
        Model._applyStringAttributes(objInstance, n);
      else if (name == "variants")
        Model._applyVariantAttributes(objInstance, n);
      else if (name == "dynamics")
        Model._bindObjectProperty(objInstance, n, "_jsxdynamic");
      else if (name == "properties")
        Model._bindObjectProperty(objInstance, n, "jsxcustom");
      else if (name == "events")
        Model._bindObjectProperty(objInstance, n, "_jsxevents");
      else if (name == "xslparameters")
        Model._bindObjectProperty(objInstance, n, "jsxxslparams");
    }

    var strName = objInstance.getName();
    if (strName) {
      loadContext.nameIndex[strName] = objInstance;
      if (strName.match(/^[\\$_a-zA-Z][\w\\$]*$/)) // only put names that are valid variable names into this index
        loadContext.varNameIndex[strName] = objInstance;
    }

    //recurse to bind children
    var i = objXML.selectNodeIterator("jsx1:object | jsx1:include | jsx1:children/jsx1:object | jsx1:children/jsx1:include");

    while (i.hasNext()) {
      var objItem = i.next();

      if (objItem.getBaseName() == "object") {
        //during recursion all descendants are embedded, since this is how they exist in the serialization file
        var objNewChild = objInstance._doLoad(objItem, strSourceURL, strNS, objServer, objCache, objResolver, loadContext);
        if (objNewChild) {
	  objInstance.setChild(objNewChild, Model.PERSISTEMBED, null, strNS);
	}
      } else if (objItem.getBaseName() == "include") {
        // resolver the referenced component file relative to this DOM node
        var rawURL = objItem.getAttribute("src");
        var strMyURL = objResolver.resolveURI(rawURL);
        var refSync = true;

        //branch based on async or not
        if (objItem.getAttribute("async") == "true") {
          refSync = false;

          if (i.hasNext()) {
            jsx3.util.Logger.GLOBAL.warn(jsx3._msg("model.async_convt", objInstance));
            refSync = true;
          }
        }

        if (refSync) {
          //this is a synchronouns load; just request the resource
          var objRefXML = objCache != null ? objCache.getOrOpenDocument(strMyURL) : (new Document()).load(strMyURL);

          if (objRefXML.hasError())
            throw new jsx3.Exception(jsx3._msg("model.bad_comp", strMyURL, objXML.getError()));

          objInstance._loadObject(objRefXML, false, Model.PERSISTREF, strMyURL, rawURL, strNS, objCache, null, objServer);
        } else {
          objInstance._doLoadAsync(strMyURL, rawURL, strNS, objCache, objServer);
        }
      } else {
        throw new jsx3.Exception();
      }
    }

    objInstance.onAfterAssemble(this, objServer);
    //return the object instance
    return objInstance;
  };

  Model_prototype.onBeforeAssemble = function(objParent, objServer) {
  };

  Model_prototype.onAfterAssemble = function(objParent, objServer) {
  };

  Model_prototype.onAfterAttach = function() {
    // NOTE: DOM nodes are notified of attachment from the deepest to the root
    // defensive backup prevents double execution of this method per node if the DOM is modified by the onafter script
    var children = this.getChildren().concat();
    for (var i = children.length - 1; i >= 0; i--) {
      if (children[i]._jsxparent == this)
        children[i].onAfterAttach();
    }

    //3.6 Templating language udpate: this is a no-op for pre-migrated controls; ensures that all dynprops are run after attachment--
    //(this ensures that they are not redundantly re-run each time paint is called)
    if(this.hasPaintProfile())
      this.applyDynamicProperties();

    var onAfter = this.getMetaValue("onafter");
    if (onAfter) {
      try {
        var loadContext = this._jsxloadcontext;
        var objContext = loadContext ? jsx3.$O(loadContext.varNameIndex).clone() : {};
        objContext.objJSX = this;
        this.eval(onAfter, objContext);
      } catch (e) {
        var strSourceUrl = this.getMetaValue("url");
        jsx3.util.Logger.GLOBAL.error(jsx3._msg("model.onafter", strSourceUrl), jsx3.NativeError.wrap(e));
      }
    }
  };

  Model_prototype._doLoadAsync = function(strURL, rawURL, strNS, objCache, objServer) {
    var me = this;

    if (objCache != null && objCache.getDocument(strURL.toString()) != null) {
      var objXML = objCache.getDocument(strURL.toString());
      jsx3.sleep(function() {
        this._loadObject(objXML, true, Model.PERSISTREFASYNC, strURL, rawURL, strNS, objCache, null, objServer);
      }, null, this);
    } else {
      var objXML = new Document();
      objXML.setAsync(true);

      objXML.subscribe(Document.ON_RESPONSE, function(objEvent) {
        if (objCache != null)
          objCache.setDocument(strURL, objEvent.target);

        me._loadObject(objEvent.target, true, Model.PERSISTREFASYNC, strURL, rawURL, strNS, objCache, null, objServer);
      });
      objXML.subscribe([Document.ON_ERROR, Document.ON_TIMEOUT], function(objEvent) {
        throw new jsx3.Exception(jsx3._msg("model.bad_comp", strURL, objEvent.target.getError()));
      });

      objXML.load(strURL, Model.ASYNC_LOAD_TIMEOUT);
    }
  };

  Model._applyStringAttributes = function(objInstance, objXML) {
    var names = objXML.getAttributeNames();
    for (var i = 0; i < names.length; i++) {
      var name = names[i];
      objInstance[name] = objXML.getAttribute(name);
    }
  };

  Model._applyVariantAttributes = function(objInstance, objXML) {
    var names = objXML.getAttributeNames();
    for (var i = 0; i < names.length; i++) {
      var name = names[i];
      var strValue = objXML.getAttribute(name);
      // Checking isNaN is a 100x speedup on Fx and a 25x speedup on IE6 for all numbers
      objInstance[name] = isNaN(strValue) ? objInstance.eval(strValue) : Number(strValue);
    }
  };

  Model._bindObjectProperty = function(objInstance,objXML,strObjName) {
    //able to convert a given node in a serializattion file to a javascript object with name/value pairs
    var objTemp = objInstance[strObjName] = {};

    var names = objXML.getAttributeNames();
    for (var i = 0; i < names.length; i++) {
      var name = names[i];
      objTemp[name] = objXML.getAttribute(name);
    }
  };

  Model_prototype.toString = function() {
    return "@" + this.getClass().getName() + " " + this.getId() + "/" + this.getName();
  };

  Model.getVersion = function() {
    return "3.00.00";
  };
});

jsx3.Model = jsx3.app.Model;
