

// @jsxobf-clobber  _jsxtodo


jsx3.Class.defineClass("jsx3.app.Settings", null, null, function(Settings, Settings_prototype) {
    
  
  Settings_prototype.init = function(objXML) {
    
    this._doc = objXML || jsx3.xml.CDF.newDocument();
    
    this._root = this._doc.getRootNode();
  };

  
  Settings_prototype.get = function(strKey) {
    var value = this._getCachedValue(arguments);
    if (typeof(value) == "undefined") {
      var node = this.getNode.apply(this, arguments);
      if (node == null) return Settings.UNDEF;
      value = Settings._getRecordValue(node);
      this._cacheValue(value, arguments);
    }
    return value;
  };
  
  
  Settings_prototype.getNode = function(strKey) {
    var node = this._root;
    
    var query = "/data";
    for (var i = 0; node && i < arguments.length; i++) {
      query += "/record[@jsxid='" + arguments[i] + "']";
    }
    
    return node.selectSingleNode(query);
  };

  
  Settings_prototype._cacheValue = function(objValue, arrPath) {
    if (arrPath.length == 0) {
      
      this._cache = objValue;
    } else {
      if (!this._cache) this._cache = {_jsxtodo:true};
      var node = this._cache;
      for (var i = 0; i < arrPath.length - 1; i++) {
        var path = arrPath[i];
        if (node[path] == null) {
          node[path] = {_jsxtodo:true};
        }
        node = node[path];
      }
      node[arrPath[arrPath.length-1]] = objValue;
    }
  };
  
  
  Settings_prototype._getCachedValue = function(arrPath) {
    var node = this._cache;
    for (var i = 0; node && i < arrPath.length; i++) {
      node = node[arrPath[i]];
    }
    return (node && node._jsxtodo) ? Settings.UNDEF : node;
  };
  
  
  Settings_prototype._resetCache = function() {
    delete this._cache;
  };
  
  
  Settings._VALUE_GETTERS = {
    array: function(record) {
      var i = record.selectNodeIterator("./record");
      var a = [];
      while (i.hasNext()) {
        var x = i.next();
        var getter = Settings._VALUE_GETTERS[x.getAttribute("type")];
        a[a.length] = getter ? getter(x) : x.getValue();
      }
      return a;
    },
    map: function(record) {
      var i = record.selectNodeIterator("./record");
      var o = {};
      while (i.hasNext()) {
        var x = i.next();
        var getter = Settings._VALUE_GETTERS[x.getAttribute("type")];
        o[x.getAttribute('jsxid')] = getter ? getter(x) : x.getValue();
      }
      return o;
    },
    "number": function(record) { return Number(record.getValue()); },
    "boolean": function(record) { return record.getValue() === "true"; },
    "null": function(record) { return null; },
    "string": function(record) { return record.getValue(); },
    "eval": function(record) {
      try {
        return jsx3.eval(record.getValue());
      } catch (e) {
        return null;
      } 
    }
  };

  
  Settings._getRecordValue = function(record) {
    var type = record.getNodeName() == "data" ? "map" : record.getAttribute("type");
    var getter = Settings._VALUE_GETTERS[type];
    return getter ? getter(record) : record.getValue();
  };

  
  Settings_prototype.set = function(strKey, value) {
    var node = this._root;
    for (var i = 0; i < arguments.length - 2; i++) {
      var child = node.selectSingleNode("./record[@jsxid='" + arguments[i] + "']");

      if (child && child.getAttribute('type') != 'map') {
        node.removeChild(child);
        child = null;
      }

      if (! child) {
        child = node.createNode(jsx3.xml.Entity.TYPEELEMENT, "record");
        child.setAttribute("jsxid", arguments[i]);
        child.setAttribute("type", 'map');
        node.appendChild(child);
      }
      node = child;
    }

    Settings._setRecord(node, arguments[arguments.length - 2], arguments[arguments.length - 1]);
    this._resetCache();
  };

  
  Settings_prototype.remove = function(strKey) {
    var parent = null;
    var node = this._root;

    for (var i = 0; node && i < arguments.length; i++) {
      parent = node;
      node = node.selectSingleNode("./record[@jsxid='" + arguments[i] + "']");
    }

    if (node && parent) {
      parent.removeChild(node);
      this._resetCache();
    }
  };
  
  
  Settings._setRecord = function(parent, strKey, value) {
    var record = Settings._getOrCreateRecord(strKey, parent);
    record.removeChildren();
    var type = typeof(value);

    if (value == null || type == "undefined") {
      record.setAttribute("type", "null");
      record.setValue(null);
    } else if (type == "string" || type == "number") {
      record.setAttribute("type", type);
      record.setValue(value);
    } else if (type == "boolean") {
      record.setAttribute("type", "boolean");
      record.setValue(value ? "true" : "false");
    } else if (type == "object") {
      if (value instanceof Array) {
        record.setAttribute("type", "array");
        for (var i = 0; i < value.length; i++) {
          Settings._setRecord(record, i.toString(), value[i]);
        }
      } else {
        record.setAttribute("type", "map");
        for (var f in value) {
          Settings._setRecord(record, f, value[f]);
        }
      }
    } else if (type == "function") {
      ;
    } else {
      jsx3.ERROR.doLog("idPR02", "Cannot persist object of type " + type, 5);
    }
  };
  
  
  Settings._getOrCreateRecord = function(strKey, parent) {
    var node = parent.selectSingleNode("./record[@jsxid='" + strKey + "']");
    if (!node) {
      node = parent.createNode(jsx3.xml.Entity.TYPEELEMENT, "record");
      node.setAttribute("jsxid", strKey);
      parent.appendChild(node);
    }
    return node;
  };
  
});




jsx3.Settings = jsx3.app.Settings;


