























































































Array.prototype.indexOf = function(objElement, intStartAt) {
  if (intStartAt == null) intStartAt = 0;
  for (var i = intStartAt; i < this.length; i++) {
    if (this[i] == objElement)
      return i;
  }
  return -1;
};


Array.prototype.lastIndexOf = function(objElement, intStartAt) {
  if (intStartAt == null) intStartAt = this.length - 1;
  for (var i = intStartAt; i >= 0; i--) {
    if (this[i] == objElement)
      return i;
  }
  return -1;
};


Array.prototype.contains = function(objElement) {
  return this.indexOf(objElement) >= 0;
};


Array.prototype.remove = function(objElement) {
  var index = this.indexOf(objElement);
  if (index >= 0)
    return this.splice(index, 1)[0];
  return null;
};


Array.prototype.clone = function() {
  return this.concat();
};


Array.prototype.pushAll = function(a) {
  if (typeof(a) == "array" && a.length > 0) {
    for (var i = 0; i < a.length; i++)
      this.push(a[i]);
  } else if (typeof(a) == "object" && typeof(a.length) == "number" && a.length > 0) {
    for (var i = 0; i < a.length; i++)
      this.push(a[i]);
  }
};


Array.prototype.contentsEqual = function(a) {
  if (a == null) return false;
  if (this.length != a.length) return false;
  for (var i = 0; i < a.length; i++) {
    if (this[i] != a[i]) return false;
  }
  return true;
};


Array.prototype.filter = function(fctFilter) {
  var filtered = [];
  for (var i = 0; i < this.length; i++) {
    if (fctFilter(this[i]))
      filtered.push(this[i]);
  }
  return filtered;
};


Array.prototype.map = function(fctMapper, bExpand, bObject) {
  var mapped = null;
  if (bExpand) {
    if (bObject) {
      mapped = {};
      for (var i = 0; i < this.length; i++) {
        var pairs = fctMapper(this[i]);
        for (var j = 0; j < pairs.length; j+=2)
          mapped[pairs[i]] = pairs[i+1];
      }
    } else {
      mapped = [];
      for (var i = 0; i < this.length; i++) {
        var val = fctMapper(this[i]);
        if (val instanceof Array)
          mapped.pushAll(val);
        else
          mapped.push(val);
      }
    }
  } else {
    if (bObject) {
      mapped = {};
      for (var i = 0; i < this.length; i++) {
        var pair = fctMapper(this[i]);
        mapped[pair[0]] = pair[1];
      }
    } else {
      mapped = new Array(this.length);
      for (var i = 0; i < this.length; i++)
        mapped[i] = fctMapper(this[i]);
    }
  }
  return mapped;
};






























































Math.modpos = function(v, mod) {
  return jsx3.util.numMod(v, mod);
};


Math.isNaN = function(value) {
  return jsx3.util.numIsNaN(value);
};































Number.prototype.roundTo = function(intUnit) {
  return jsx3.util.numRound(this, intUnit);
};


Number.prototype.zeroPad = function(intDigits) {
  var s = "" + this;
  while (s.length < intDigits)
    s = "0" + s;
  return s;
};
























































































Date.prototype.getLastDateOfMonth = function() {
  var month = this.getMonth();

  return Date._LAST_DATE_ARRAY[month] ||
      ((new Date(this.getYear(), month, 29)).getMonth() == month ? 29 : 28);
};


Date.prototype.equals = function(o) {
  return o != null && o instanceof Date && o.valueOf() == this.valueOf();
};


Date.prototype.compareTo = function(d) {
  var a = this.valueOf();
  var b = d.valueOf();
  return a == b ? 0 : a > b ? 1 : -1;
};


Date._LAST_DATE_ARRAY = [31,null,31,30,31,30,31,31,30,31,30,31];









































String.prototype.trim = function() {
  return jsx3.util.strTrim(this);
};


String.prototype.doReplace = function(strReplace,strReplaceWith) {
  var re = new RegExp(strReplace,["g"]);
  return this.replace(re, strReplaceWith);
};


String.prototype.escapeHTML = function() {
  return jsx3.util.strEscapeHTML(this);
};


String.prototype.doTruncate = function(intLength) {
  return jsx3.util.strTruncate(this, intLength, "...", 1);
};


String.prototype.toAbsolute = function() {
  var s;
  //given portal implementations, any string instance that represents a URI can call this method to add a prepend of the absolute path
  if (this.substring(0,1) == "/" || this.substring(0,7).toUpperCase() == "HTTP://" || this.substring(0,8).toUpperCase() == "HTTPS://") {
    s = this.toString();
  } else if (this.substring(0,4) == "JSX/") {
    s = jsx3.getEnv("jsxabspath") + this;
  } else {
    s = jsx3.getEnv("jsxhomepath") + this;
  }
  return s;
};


String.prototype.urlTo = function(strRelative) {
  var concat = null;

  var index = this.lastIndexOf('/');
  if (index == this.length - 1)
    concat = this + strRelative;
  else if (index < 0)
    concat = strRelative;
  else
    concat = this.substring(0, index+1) + strRelative;

  concat = concat.replace(/\\/g,"/");
  var tokens = concat.split("/");

  for (var i = 0; i < tokens.length; i++) {
    var token = tokens[i];
    if (token == ".") {
      tokens.splice(i--, 1);
    } else if (token == "..") {
      if (i > 0 && tokens[i-1] != "..") {
        tokens.splice(i--, 1);
        tokens.splice(i--, 1);
      }
    }
  }

  return tokens.join("/");
};


String.prototype.endsWith = function(token) {
  return jsx3.util.strEndsWith(this, token);
};


String.prototype.constrainLength = function(intMax, ellipsis) {
  return jsx3.util.strTruncate(this, intMax, ellipsis, 2/3);
};


String.prototype.toBase64 = function() {
  return jsx3.util.strEncodeBase64(this);
};


String.prototype.fromBase64 = function() {
  return jsx3.util.strDecodeBase64(this);
};
