

// @jsxobf-clobber-shared  _stack


jsx3.Class.defineClass("jsx3.lang.NativeError", jsx3.lang.Exception, null, function(NativeError, NativeError_prototype) {

  var Exception = jsx3.Exception;

  
  NativeError.ALWAYS_ALERT_UNCAUGHT = false;
  
  NativeError.ALERT_UNCAUGHT = true;
  
  
  NativeError.wrap = function(objError) {
    // this branch is IE-specific
    if (objError instanceof Error)
      return new NativeError(objError);
    else if (objError instanceof Exception)
      return objError;
    else 
      return new Exception("" + objError);
  };
  
  
  NativeError.initErrorCapture = function(fctTrap) {
    window.onerror = arguments.length > 0 ? fctTrap : NativeError.errorTrap;
  };
  
  NativeError.stopErrorCapture = function(fctTrap) {
    window.onerror = null;
  };

 if (jsx3.CLASS_LOADER.IE) {
  
  NativeError._UNCAUGHT_MATCH = "thrown and not caught";
 } else {
  
  NativeError._UNCAUGHT_MATCH = "uncaught exception:";
 }
  
  
  NativeError.errorTrap = function(msg, url, line) {
    try {
      if (!NativeError.ALWAYS_ALERT_UNCAUGHT && 
          jsx3.Class.forName("jsx3.util.Logger") != null && jsx3.util.Logger.GLOBAL != null) {
        if (typeof(msg) == "string" && msg.indexOf(NativeError._UNCAUGHT_MATCH) >= 0) {
          if (Exception._LAST_THROWN != null) {
            var stack = jsx3.lang.getStack(0);
            if (stack.length < 2 || stack.contentsEqual(Exception._LAST_THROWN.getStack())) {
              if (stack.length < 2)
                jsx3.util.Logger.GLOBAL.logStack(jsx3.util.Logger.ERROR,
                    jsx3._msg("error.trap", msg, NativeError._convertLineNumber(line), url), 1);
              jsx3.util.Logger.GLOBAL.error(jsx3._msg("error.uncaught"), Exception._LAST_THROWN);
              Exception._LAST_THROWN = true;
              return true;
            }
          }
        }
        // IE interprets line numbers incorrectly (one off)
        jsx3.util.Logger.GLOBAL.logStack(jsx3.util.Logger.ERROR,
            jsx3._msg("error.trap", msg, NativeError._convertLineNumber(line), url), 1);
        return true;
      } else if (NativeError.ALERT_UNCAUGHT) {
        if (typeof(msg) == "string" && msg.indexOf(NativeError._UNCAUGHT_MATCH) >= 0) {
          if (Exception._LAST_THROWN != null) {
            var stack = jsx3.lang.getStack(0);
            if (stack.contentsEqual(Exception._LAST_THROWN.getStack())) {
              window.alert(jsx3._msg("error.uncaught") + "\n" + Exception._LAST_THROWN.printStackTrace());
              return true;
            }
          }
        }
        
        var stack = jsx3.lang.getStack(0);
        window.alert(jsx3._msg("error.trap", msg, NativeError._convertLineNumber(line), url) +
            "\n" + Exception.formatStack(stack));
        return true;
      } else {
        return false;
      }
    } catch (e) {
      window.alert(jsx3._msg("error.trap_err", NativeError.wrap(e), msg, NativeError._convertLineNumber(line), url));
    }
  };
  
  
  NativeError_prototype._error = null;
    
  
  NativeError_prototype.init = function(objError) {
    if (!(objError instanceof Error))
      throw new jsx3.IllegalArgumentException("objError", objError);
    
    this._error = objError;
    this.jsxsuper();
  };

  
  NativeError_prototype.getMessage = function() {
    return (this._error.message || this._error.toString()).replace(/\s*$/,"");
  };

  
  NativeError_prototype.getFileName = function() {
 if (jsx3.CLASS_LOADER.SAF) {
    return this._error.sourceURL;
 } else {
    return this._error.fileName;
 }
  };

  
  NativeError_prototype.getLineNumber = function() {
 if (jsx3.CLASS_LOADER.SAF) {
    return this._error.line;
 } else {
    return NativeError._convertLineNumber(this._error.lineNumber);
 }
  };

  
  NativeError._convertLineNumber = function(line) {
    if (jsx3.util.numIsNaN(line)) return null;
 if (jsx3.CLASS_LOADER.IE) {
    return line - 1;
 } else {
    return line;
 }
  };

  
  NativeError_prototype.getName = function() {
    return this._error.name;
  };



  
  NativeError_prototype.isStructural = function() {
 if (jsx3.CLASS_LOADER.IE) {
    return this._error && (this._error.number & 0xFFFF) == 1009;
 } else {
    return false;
 }
  };


  
  NativeError_prototype.getType = function() {
    if (this._error instanceof EvalError) return "EvalError";
    if (this._error instanceof RangeError) return "RangeError";
    if (this._error instanceof ReferenceError) return "ReferenceError";
    if (this._error instanceof SyntaxError) return "SyntaxError";
    if (this._error instanceof TypeError) return "TypeError";
    return "Error";
  };

  NativeError_prototype.printStackTrace = function() {
    var s = this.getClass().getName() + ": " + this + "\n" + Exception.formatStack(this._stack);

    if (this._error.stack)
      s += "\n" + this._error.stack;

    if (this._cause != null)
      s += "\nCaused By:\n" + this._cause.printStackTrace();

    return s;
  };

  
  NativeError_prototype.toString = function() {
    var line = this.getLineNumber();
    var file = this.getFileName();
    var s = this.getMessage();
    if (line || file) {
      s += " (type:" + this.getType() + ", ";
      if (line) s += "line:" + line;
      if (file) {
        if (line) s += ", ";
        s += "file:" + file;
      }
      s += ")";
    }
    return s;
  };

});
  
