

// @jsxobf-clobber-shared  _name _class _static _packageDidLoad

jsx3.lang.Package = jsx3.lang.newPrivateConstructor();

jsx3.lang.Class.defineClass("jsx3.lang.Package", null, null, function(Package, Package_prototype) {
  
  // imports
  var Class = jsx3.lang.Class;
  var Method = jsx3.lang.Method;
  
  
  Package._PACKAGES = [];
  
  Package.definePackage = function(strName, fctBody) {
    var objOwner = Class._getOrCreatePackage(strName.split("."));

    var bRedefinition = false;
    var objPackage = null;
    if (objOwner.jsxpackage != null) {
      if (jsx3.Class.forName("jsx3.util.Logger"))
        jsx3.util.Logger.getLogger("jsx3.lang").info(jsx3._msg("pkg.redefine", strName));

      objPackage = objOwner.jsxpackage;
      bRedefinition = true;
      objPackage._staticFields = [];
      objPackage._staticMethods = [];
    } else {
      objPackage = Class._newInstanceForce(Package);
      objPackage._pname = strName;
      objPackage._staticFields = [];
      objPackage._staticMethods = [];
      objOwner.jsxpackage = objPackage;    
    }
    
    try {
      fctBody(objOwner);
    } catch (e) {
      var ex = jsx3.NativeError.wrap(e);
      throw new jsx3.Exception(jsx3._msg("pkg.def_error", strName, ex), ex);
    }
    
    // define static methods
    for (var f in objOwner) {
      if (f == "jsxpackage") continue;
      if (typeof(objOwner[f]) == "function") {
        // don't define classes as static methods
        if (objOwner[f].jsxclass == null)
          this._blessMethod(objOwner[f], objPackage, f);
      } else {
        // don't define packages as static fields
        if (objOwner[f] == null || typeof(objOwner[f]) != "object" || objOwner[f].jsxpackage == null)
          objPackage._staticFields.push(f);
      }
    }
    
    // define no such method catch-all for Mozilla
    if (objOwner.__noSuchMethod__ == null)
      objOwner.__noSuchMethod__ = function(strMethod, args) {
        throw new jsx3.Exception(jsx3._msg("class.nsm", strName + "#" + strMethod + "()"));
      };
    
    Package._PACKAGES.push(objPackage);
    
    jsx3.CLASS_LOADER._packageDidLoad(objPackage);
  };
  
  
  Package._blessMethod = function(fctMethod, objPackage, strName) {
    if (fctMethod.jsxmethod instanceof Method) {
      // renaming a method in this package is an error
      if (fctMethod.jsxmethod.getDeclaringClass().equals(objPackage) && fctMethod.jsxmethod.getName() != strName) {
        throw new jsx3.Exception(jsx3._msg("class.redef_method", fctMethod.jsxmethod, objPackage + "." + strName));
      } else {
        if (fctMethod.jsxmethod.getDeclaringClass().equals(objPackage) && 
            jsx3.util.arrIndexOf(objPackage._staticMethods, fctMethod.jsxmethod) < 0)
          objPackage._staticMethods.push(fctMethod.jsxmethod);
        return;
      }
    }
    
    var objMethod = Class._newInstanceForce(Method);
    objMethod._class = objPackage;
    objMethod._name = strName;
    objMethod._static = true;

    fctMethod.jsxmethod = objMethod;
  
    objPackage._staticMethods.push(objMethod);
  };
  
  Package.forName = function(strName) {
    var c = jsx3.lang.getVar(strName);
    return c ? c.jsxpackage : null;
  };
  
  
  Package.getPackages = function() {
    return Package._PACKAGES.concat();
  };
  
  
  Package_prototype._pname = null;
  
  Package_prototype._owner = null;
  
  Package_prototype._staticMethods = null;
  
  Package_prototype._staticFields = null;
  
  
  Package_prototype.getName = function() {
    return this._pname;
  };
  
  Package_prototype.getNamespace = function() {
    if (this._owner != null) return this._owner;
    var c = jsx3.lang.getVar(this._pname);
    return c || null;
  };
  
  
  Package_prototype.getClasses = function() {
    var classes = [];
    var owner = this.getNamespace();
    for (var f in owner) {
      if (typeof(owner[f]) == "function" && owner[f].jsxclass instanceof Class) {
        if (owner[f].jsxclass.getPackage() == this && 
            (this.getName() + "." + f) == owner[f].jsxclass.getName()) {
          classes[classes.length] = owner[f].jsxclass;
          classes.push.apply(classes, owner[f].jsxclass.getClasses());
        }
      }
    }
    return classes;
  };
  
  
  Package_prototype.getStaticMethods = function() {
    return this._staticMethods.concat();
  };
  
  
  Package_prototype.getStaticMethod = function(strMethodName) {
    for (var i = 0; i < this._staticMethods.length; i++) {
      if (strMethodName == this._staticMethods[i].getName())
        return this._staticMethods[i];
    }
    return null;
  };
  
  
  Package_prototype.getStaticFieldNames = function() {
    return this._staticFields.concat();
  };
  
  
  Package_prototype.toString = function() {
    return this._pname;
  };
  
});
