


jsx3.Class.defineClass("jsx3.lang.System", null, null, function(System, System_prototype) {

  System.LJSS = new jsx3.app.Properties();
  
  
  System.JSS = new jsx3.app.Properties();
  System.JSS.addParent(System.LJSS);
  
  
  System.APPS = {};
  
  
  System.getProperty = function(strKey) {
    return System.JSS.get(strKey);
  };

  
  System.getLocale = function() {
    // Locale is optional
    if (System._locale == null && jsx3.util.Locale) {
      var localeString = jsx3.app.Browser.getLocaleString();
      if (localeString) {
        var tokens = localeString.split("_");
        System._locale = new jsx3.util.Locale(tokens[0], tokens[1]);
      } else {
        System._locale = jsx3.util.Locale.US;
      }
    }
    return System._locale;
  };

  
  System.setLocale = function(objLocale) {
    if (objLocale != System._locale) {
      System.JSS.removeParent(System.getLocaleProperties());
      
      System._locale = objLocale;
      System.JSS.addParent(System.getLocaleProperties());
    }
  };
  
  
  System.reloadLocalizedResources = function() {
    var PropsBundle = jsx3.app.PropsBundle;
    
    if (PropsBundle) {
      var p = System.LJSS.getParents();
      System.LJSS.removeAllParents();
    
      for (var i = 0; i < p.length; i++)
        System.LJSS.addParent(jsx3.app.PropsBundle.getProps(p[i].getPath(), System.getLocale(), jsx3.getSystemCache()));
    }
  };

  
  System._locdocurl = jsx3.resolveURI("jsx:///locale/locale.xml");

  
  System.getLocaleProperties = function(objLocale) {
    return jsx3.app.PropsBundle.getProps(System._locdocurl, objLocale, jsx3.getSystemCache());
  };

  
  System.getMessage = function(strKey, strTokens) {
    var value = System.LJSS.get(strKey);
    var suffix = "";

    // jsx3.util.MessageFormat class is optional, should work without it
    if (arguments.length > 1) {
      var args = jsx3.Method.argsAsArray(arguments, 1);
      if (value != null && jsx3.util.MessageFormat) {
        try {
          var format = new jsx3.util.MessageFormat(value);
          return format.format(args);
        } catch (e) {;}
      } else {
        suffix = " " + args.join(" ");
      }
    }

    if (value == null) value = strKey;
    return value + suffix;
  };

  
  System.GO = function(strIdName, strNS) {
    var objJSX = null;
    if (strIdName != null) {
      // check for argument like jsxid, only check by id
      if (strIdName.indexOf("_jsx_") == 0) {
        var appKey = jsx3.app.DOM.getNamespaceForId(strIdName);
        
        // namespace argument does not match the namespace encoded in the id
        if (strNS && strNS != appKey) return null;
        
        if (System.APPS[appKey])
          objJSX = System.APPS[appKey].getJSXById(strIdName);
      } 
      // it must be a name, we'll check APPS, then all servers
      else {
        // namespace specified
        if (strNS) {
          if (System.APPS[strNS])
            objJSX = System.APPS[strNS].getJSXByName(strIdName);
        } else {
          for (var i in System.APPS) 
            if ((objJSX = System.APPS[i].getJSXByName(strIdName)) != null) return objJSX;
        }
      }
    }
    return objJSX;
  };

  
  System.getApp = function(strAppKey) {
    return System.APPS[strAppKey];
  };
  
  
  System.getAllApps = function() {
    var apps = [];
    for (var f in System.APPS)
      apps.push(System.APPS[f]);
    return apps;
  };

  
  System.registerApp = function(objServer) {
    var ns = objServer.getEnv('namespace');

    jsx3.lang.setVar(ns, objServer);
  
    // add this server instance to the collection indexed and managed by the JSX controller
    System.APPS[ns] = objServer;  
  };

  
  System.deregisterApp = function(objServer) {
    var ns = objServer.getEnv('namespace');

    var s = jsx3.lang.getVar(ns);
    if (objServer == s)
      jsx3.lang.setVar(objServer.getEnv('namespace'), null);
    
    if (System.APPS[ns] == objServer) 
      delete System.APPS[ns];
  };

  
  System.activateApp = function(objServer) {
    jsx3.registerApp(objServer);
  };

  
  System.getAppByPath = function(strPath) {
    for (var ns in System.APPS) {
      var app = System.APPS[ns];
      if (app.getEnv("apppathrel") == strPath || app.getEnv("apppath") == strPath)
        return app;
    }
    return null;
  };

  
  System._ADDINS = [];
  
  
  System._ADDIN_MAP = {};
  
  
  System.registerAddin = function(strVar, objAddin) {
    jsx3.lang.setVar(strVar, objAddin);
    System._ADDINS.push(objAddin);
    System._ADDIN_MAP[objAddin.getKey()] = objAddin;
  };
  
  
  System.getAddins = function() {
    return System._ADDINS.concat();
  };

  
  System.getAddin = function(strKey) {
    return System._ADDIN_MAP[strKey];
  };

  
  System.getVersion = function() {
    var v = "@build.gi.version@.@build.version.buildno@";
    return v.match(/\d/) ? v : "3.7.0"; // fallback for uncompiled version
  };

});

// jsx3.lang.System
jsx3.GO =            jsx3.lang.System.GO;
jsx3.getApp =        jsx3.lang.System.getApp;
jsx3.registerApp =   jsx3.lang.System.registerApp;
jsx3.activateApp =   jsx3.lang.System.activateApp;
jsx3.deregisterApp = jsx3.lang.System.deregisterApp;
jsx3.getVersion =    jsx3.lang.System.getVersion;
