

// @jsxobf-clobber-shared  _initFromReq


jsx3.Class.defineClass("jsx3.net.Request", null, [jsx3.util.EventDispatcher], function(Request, Request_prototype) {

  
  Request.STATUS_OK = 200;

  
  Request.STATUS_ERROR = 400;

  
  Request.EVENT_ON_RESPONSE = "response";

  
  Request.EVENT_ON_TIMEOUT = "timeout";


  
  Request.trackArray = {};


  
  Request_prototype.init = function(id) {

    if (id != null)
      Request.trackArray[id] = this;


 if (jsx3.CLASS_LOADER.IE) {
    try {
      
      this._request = jsx3.getHttpInstance();
    } catch (e) {
      throw new jsx3.Exception(jsx3._msg("req_inst"), jsx3.NativeError.wrap(e));
    }
 } else {
    try {
      this._request = new XMLHttpRequest();
    } catch (e) {
      throw new jsx3.Exception(jsx3._msg("req_inst"), jsx3.NativeError.wrap(e));
    }
 }
  };

  
  Request_prototype.abort = function() {
    if (this._timeoutto) {
      window.clearTimeout(this._timeoutto);
      delete this._timeoutto;
    }

    this._request.onreadystatechange = new Function();

    //call the native abotr
    this._request.abort();
    return this;
  };

  
  Request_prototype.getAllResponseHeaders = function() {
    return this._request.getAllResponseHeaders();
  };

  
  Request_prototype.getResponseHeader = function(strName) {
    try {
      return this._request.getResponseHeader(strName);
    } catch (e) {
      return null;
    }
  };

  
  Request_prototype.getStatusText = function() {
    return this._request.statusText;
  };

  
  Request_prototype.getStatus = function() {
    var s = this._status != null ? this._status : this._request.status;
 if (jsx3.CLASS_LOADER.SAF) {
    // HACK: http://bugs.webkit.org/show_bug.cgi?id=14831
    if (s < 0 || s == 112 || s >= 600) s = Request.STATUS_ERROR;
 }
    
    return s == 0 ? Request.STATUS_OK : s;
  };

  
  Request_prototype.getResponseText = function() {
    return this._request.responseText;
  };

  
  Request_prototype.getResponseXML = function() {
    var objDoc = new jsx3.xml.Document();
    objDoc._initFromReq(this);

    if (!objDoc.hasError()) {
      return objDoc;
    } else {
      Request._log(2, jsx3._msg("req.bad_xml", this._url, objDoc.getError()));
      return null;
    }
  };

  
  Request_prototype.getNative = function() {
    return this._request;
  };

  
  Request_prototype.setRequestHeader = function(strName, strValue) {
    this._request.setRequestHeader(strName, String(strValue));
    return this;
  };



  
  Request_prototype.getReadyState = function() {
    //get handle to the XMLHTTP object associated with the SOAPSocket instance
    return this._request.readyState;
  };

  
  Request.open = function(strMethod, strURL, bAsync, strUser, strPass) {
    var url = jsx3.net.URI.valueOf(strURL);
    var scheme = url.getScheme();
    var handler = Request._HANDLERS[scheme] || Request.jsxclass;
    return (handler.newInstance()).open(strMethod, url, bAsync, strUser, strPass);
  };



  Request._HANDLERS = {};

  
  Request.addSchemeHandler = function(scheme, handler) {
    Request._HANDLERS[scheme] = handler;
  };

  
  Request.getSchemeHandler = function(scheme) {
    return Request._HANDLERS[scheme];
  };

  
  Request_prototype.open = function(strMethod, strURL, bAsync, strUser, strPass) {
//    if (!bAsync) {
//      Request._log(3, "Synchronous request to: " + strURL);
////      if (Request._LOG)
////        Request._LOG.logStack(4, "");
//    }

    this._status = 0;

    
    this._async = Boolean(bAsync);
    
    this._method = strMethod;
    
    this._url = jsx3.net.URIResolver.DEFAULT.resolveURI(strURL);

 if (! jsx3.CLASS_LOADER.IE) {
      try {
        if (window.netscape && netscape.security)
          netscape.security.PrivilegeManager.enablePrivilege('UniversalBrowserRead');
      } catch (e) {
        Request._log(5, jsx3._msg("req.netsc", jsx3.NativeError.wrap(e)));
      }
 }

    //open the request, passing in relevant info and return object ref
    try {
      Request._log(6, jsx3._msg("req.open", this._url));
      this._request.open(strMethod, this._url.toString(), this._async, strUser, strPass);
    } catch (e) {
      this._status = Request.STATUS_ERROR; // communicate failure to client
      Request._log(2, jsx3._msg("req.err_open", strURL, jsx3.NativeError.wrap(e)));
    }

    return this;
  };



  
  Request.cancelRequest = function(strRequestId) {
    var r = Request.trackArray[strRequestId];
    if (r) r.abort();
  };

  
  Request.getRequest = function(strRequestId) {
    return Request.trackArray[strRequestId];
  };



  
  Request_prototype.getURL = function() {
    return this._url && this._url.toString();
  };



  
  Request_prototype.setTimeouts = function(intResolveTimeout,intConnectTimeout,intSendTimeout,intReceiveTimeout) {
 if (jsx3.CLASS_LOADER.IE) {
    try {
      this._request.setTimeouts(intResolveTimeout,intConnectTimeout,intSendTimeout,intReceiveTimeout);
    } catch (e) {
      Request._log(3, "The HTTP ActiveX object does not appear to support setting timeouts.");
    }
 }
    return this;
  };



  
  Request_prototype.send = function(strContent, intTimeout) {
    if (this._status == Request.STATUS_ERROR)
      throw new jsx3.Exception(jsx3._msg("req.err_state"));


    var t1 = new jsx3.util.Timer(Request.jsxclass, this._url);


    var bError = false;

    try {
      this._request.send(strContent);

      if (this._async)
        
        this._status = 0;
      else
        delete this._status;

    } catch (e) {
      // TODO: communicate failure to client
      this._status = Request.STATUS_ERROR; // Firefox seems to still report status as 0 when error on local file access.
      Request._log(2, jsx3._msg("req.err_send", this._url, jsx3.NativeError.wrap(e)));
      bError = this;
    }

    // if this async, add the request object to the array of
    if (this._async) {
      if (bError || this._request.readyState == 4) {
        // If async, events should always be published asynchronously.
        jsx3.sleep(function() {

          t1.log("load.async");

          this.publish({subject:Request.EVENT_ON_RESPONSE});
        }, null, this);
      } else {
        var me = this;
        this._request.onreadystatechange = function() {
          if (me._request.readyState == 4) {

            t1.log("load.async");

            me._onReadyStateChange();
          }
        };

        if (!isNaN(intTimeout) && intTimeout > 0) {
          //set timeout to fire if the response doesn't happen in time
          this._timeoutto = window.setTimeout(function() {

            t1.log("timeout");

            me._onTimeout();
          }, intTimeout);
        }
      }
    }

    else {
      t1.log("load.sync");
    }


    return this;
  };

  
  Request_prototype._onTimeout = function() {
    delete this._timeoutto;
    this.abort();
    this._status = 408; // request timeout
    this.publish({subject:Request.EVENT_ON_TIMEOUT});
  };

  
  Request_prototype._onReadyStateChange = function() {
    delete this._status;

    if (this._timeoutto) {
      window.clearTimeout(this._timeoutto);
      delete this._timeoutto;
    }

    this._request.onreadystatechange = new Function();

    this.publish({subject:Request.EVENT_ON_RESPONSE});
  };

  Request_prototype.toString = function() {
    return this.jsxsuper() + " " + this._method + " " + this.getStatus() + " " + this._url;
  };

  
  Request._log = function(intLevel, strMessage) {
    if (Request._LOG == null) {
      if (jsx3.util.Logger) {
        
        Request._LOG = jsx3.util.Logger.getLogger(Request.jsxclass.getName());
        if (Request._LOG == null) return;
      } else {
        return;
      }
    }
    Request._LOG.log(intLevel, strMessage);
  };



  
  Request.getVersion = function() {
    return "3.00.00";
  };



});




jsx3.HttpRequest = jsx3.net.Request;


