


jsx3.Class.defineInterface("jsx3.util.EventDispatcher", null, function(EventDispatcher, EventDispatcher_prototype) {
  
  
  EventDispatcher._OBJ_FUNCT = 1;

  
  EventDispatcher._OBJ_STRING = 2;


  
  EventDispatcher._STRING_FUNCT = 3;

  
  EventDispatcher._STRING_STRING = 4;


  
  EventDispatcher._FUNCT = 5;
  
  
  EventDispatcher.SUBJECT_ALL = "*";

  
  EventDispatcher_prototype.subscribe = function(strEventId, objHandler, objFunction) {
    var type1 = typeof(objHandler);
    var type2 = typeof(objFunction);
    
    var toAdd = null;
    if (type1 == "object" || type1 == "function") {
      if (type2 == "function") {
        toAdd = [EventDispatcher._OBJ_FUNCT, objHandler, objFunction];
      } else if (type2 == "string") {
        toAdd = [EventDispatcher._OBJ_STRING, objHandler, objFunction];
      } else if (type1 == "function") {
        toAdd = [EventDispatcher._FUNCT, objHandler];
      }

    } else if (type1 == "string") {
      if (type2 == "function") {
        toAdd = [EventDispatcher._STRING_FUNCT, objHandler, objFunction];
      } else if (type2 == "string") {
        toAdd = [EventDispatcher._STRING_STRING, objHandler, objFunction];
      }

    }
    
    // HACK: function subscriptions coming from other browser windows will be reported as type "object" in IE
    if (toAdd == null && (type1 == "object" && objHandler.call && objHandler.apply))
      toAdd = [EventDispatcher._FUNCT, objHandler];
    
    if (toAdd == null) {
      throw new jsx3.IllegalArgumentException("objHandler, objFunction",
          "{" + typeof(objHandler) + "}, {" + typeof(objFunction) + "}");
    }
    
    if (!(strEventId instanceof Array)) strEventId = [strEventId];
    
    for (var i = 0; i < strEventId.length; i++) {
      var registry = this._getEventRegistry();
      var eventId = strEventId[i];
      
      if (!registry[eventId])
        registry[eventId] = [toAdd];
      else
        registry[eventId].push(toAdd);
    }
  };

  
  EventDispatcher_prototype.unsubscribe = function(strEventId, objHandler) {
    if (!(strEventId instanceof Array)) strEventId = [strEventId];
    
    for (var i = 0; i < strEventId.length; i++) {
      var queue = this._getEventRegistry()[strEventId[i]];
      if (queue) {
        for (var j = 0; j < queue.length; j++) {
          if (queue[j][1] === objHandler)
            queue.splice(j--, 1);
        }
      }
    }
  };

  
  EventDispatcher_prototype.unsubscribeAll = function(strEventId) {
    if (this._jsxeventreg)
      delete this._jsxeventreg[strEventId];
  };

  EventDispatcher_prototype.unsubscribeAllFromAll = function() {
    this._jsxeventreg = {};
  };
  
  
  EventDispatcher_prototype.publish = function __EventDispatcher_prototype_publish(objEvent) {
    // always set the event target
    if (objEvent.target == null)
      objEvent.target = this;
    
    var strEventId = objEvent.subject;
    if (strEventId == null)
      throw new jsx3.IllegalArgumentException("objEvent", objEvent);
    
    var reg = this._jsxeventreg;

    if (!reg) return;

    var q1 = reg[strEventId];
    var q2 = reg[EventDispatcher.SUBJECT_ALL];

    if (!q1 && !q2) return;

    // defensive copy: subscribers may unsubscribe themselves
    var queue = [];
    if (q1) queue.push.apply(queue, q1);
    if (q2) queue.push.apply(queue, q2);

    for (var i = 0; i < queue.length; i++) {
      var item = queue[i];
      var type = item[0];
      var target = item[1];
      var method = item[2];

      if (type == EventDispatcher._OBJ_FUNCT) {
        method.call(target, objEvent);
      } else if (type == EventDispatcher._OBJ_STRING) {
        target[method](objEvent);

      } else if (type == EventDispatcher._STRING_FUNCT) {
        var objJSX = this.getServer().getJSX(target);
        if (objJSX)
          method.call(objJSX, objEvent);
      } else if (type == EventDispatcher._STRING_STRING) {
        var objJSX = this.getServer().getJSX(target);
        if (objJSX)
          objJSX[method](objEvent);

      } else if (type == EventDispatcher._FUNCT) {
        target.call(null, objEvent);
      } else {
        // assert false
      }
    }
    
    return queue.length;
  };
  
  EventDispatcher_prototype.getSubscriberCount = function(strEventId) {
    var list = this._getEventRegistry()[strEventId];
    return list ? list.length : 0;
  };
  
  
  EventDispatcher_prototype._getEventRegistry = function() {
    if (this._jsxeventreg == null)
      this._jsxeventreg = {};
    return this._jsxeventreg;
  };

});

jsx3.util.EventDispatcher.jsxclass.mixin(jsx3);




jsx3.EventDispatcher = jsx3.util.EventDispatcher;


