


jsx3.Class.defineClass('jsx3.util.Locale', null, null, function(Locale, Locale_prototype) {
      
  
  Locale_prototype.init = function(strLanguage, strCountry) {
    
    this._lang = strLanguage ? strLanguage.toLowerCase() : "";
    
    this._country = strCountry ? strCountry.toUpperCase() : "";
  };
  
  
  Locale.ENGLISH = new Locale("en");
  
  Locale.US = new Locale("en", "US");
  
  Locale.UK = new Locale("en", "GB");
    
  
  Locale_prototype.getLanguage = function() {
    return this._lang;
  };
  
  
  Locale_prototype.getCountry = function() {
    return this._country;
  };
  
  
  Locale_prototype.getDisplayLanguage = function(objLocale) {
    return jsx3.System.getLocaleProperties(objLocale).get("string.lang." + this._lang) || "";
  };
  
  
  Locale_prototype.getDisplayCountry = function(objLocale) {
    return jsx3.System.getLocaleProperties(objLocale).get("string.terr." + this._country) || "";
  };
  
  
  Locale_prototype.getDisplayName = function(objLocale) {
    var language = this.getDisplayLanguage(objLocale);
    var country = this.getDisplayCountry(objLocale);
    if (! language) return country;
    if (! country) return language;
    
    var format = jsx3.System.getLocaleProperties(objLocale).get("format.locale.displayname");
    return (new jsx3.util.MessageFormat(format)).format(language, country);
  };

  
  Locale_prototype.getSearchPath = function() {
    var path = [this];
    if (this._country != "" || this._lang != "") {
      if (this._country != "" && this._lang != "")
        path.push(new Locale(this._lang));
      path.push(new Locale(""));
    }
    return path;
  };
  
  
  Locale_prototype.equals = function(obj) {
    return this === obj || (obj instanceof Locale && obj._lang == this._lang && obj._country == this._country);
  };
  
  
  Locale_prototype.toString = function() {
    if (this._country)
      return this._lang + "_" + this._country;
    else
      return this._lang;
  };
  
  
  Locale.valueOf = function(strKey) {
    var tokens = strKey.split(/[\-_]/);
    return new Locale(tokens[0], tokens[1]);
  };
  
});
