

// @jsxobf-clobber-shared  setError _jsxselectionns _jsxselectionnsobj
// @jsxobf-clobber  _document _jsx_sn_hash


jsx3.Class.defineClass("jsx3.xml.Document", jsx3.xml.Entity, [jsx3.util.EventDispatcher], function(Document, Document_prototype) {

  var Entity = jsx3.xml.Entity;

  
  Document.ON_RESPONSE = "response";

  
  Document.ON_ERROR = "error";

  
  Document.ON_TIMEOUT = "timeout";

  
  Document.SEARCHABLE_NAMESPACE = "http://xsd.tns.tibco.com/gi/cxf/2006";

  
  Document.SEARCHABLE_PREFIX = "jsx_xmlns";

  
  Document.SEARCHABLE_REGEXP = /xmlns:([^=]*)=['"]([^"^']*)['"]/g;

 if (jsx3.CLASS_LOADER.IE) {
  try {
    // HACK: turns out that calling this once and then cloning the document is 3x faster on IE6
    
    var p = Document._PROTO = jsx3.getXmlInstance();
    p.setProperty("SelectionLanguage", "XPath");
    p.async = false;
    p.validateOnParse = false;
    p.resolveExternals = false;
    p.preserveWhiteSpace = true;
    p.setProperty("ForcedResync", false); // Lets IE use cached version of file.
  } catch (e) {
    window.alert(jsx3.NativeError.wrap(e));
  }
 }

  
  Document_prototype.init = function(objDoc) {
    var bEnt = objDoc instanceof Entity;
    if (!objDoc || bEnt) {
      try {
 if (jsx3.CLASS_LOADER.IE) {
        if (Document._PROTO == null) {
          this.setError(100, jsx3._msg("xml.parser", null));
          return;
        }

        this._document = Document._PROTO.cloneNode(true);
        
        //3.2 update: as of the 4.0 version of the msxml parser, the following settings were defaulted to 'true' (as opposed to false for the 3.0 version).
        //this is being explicitly set to provide consistency
 } else {
        //TODO: need to see if Safari has a setting or call to use here that won't create a document that defaults to the xhtml namespace (or the namespace of the browser document)
        this._document = window.document.implementation.createDocument("", "", null);
 }
      } catch (e) {
        this.setError(101, jsx3._msg("xml.parser", jsx3.NativeError.wrap(e)));
        delete this._document;
      }

      if (objDoc) {
        this._document.appendChild(objDoc.getNative().cloneNode(true));
        this.jsxsuper(this._document.documentElement);
      }
    } else {
      this._document = objDoc;
      this.jsxsuper(objDoc.documentElement);
    }
  };

  
  Document_prototype.load = function(strURL, intTimeout) {
    var net = jsx3.net;
    var Request = net.Request;

    
    this._url = strURL.toString();

    //reset error state (used by hasError)
    this.setError(0);

    //set whether or not the doc should load synchronously; if an error is thrown and mode is firefox, probably due to document.domain issue
    var bAsync = Boolean(this.getAsync());

    var req = Request.open("GET", strURL, bAsync);

    if (req.getStatus() != Request.STATUS_ERROR) {
      if (bAsync)
        req.subscribe("*", this, "_onRequestEvent");

      req.send(null, intTimeout);
    }

    if (!bAsync)
      this._initFromReq(req);

    return this;
  };
  
  
  Document_prototype._initFromReq = function(objReq) {
    var url = this._url;
    this._initFromReq2(objReq);
    this._url = url;

    if (this.hasError())
      this.publish({subject:Document.ON_ERROR});
    else
      this.publish({subject:Document.ON_RESPONSE});
  };
  
  
  Document_prototype._initFromReq2 = function(objReq) {
    //LUKE (3.6.2/3.7): the following is an attempt to determine if an XML document should even be loaded via getResponseXML
    //Since the document class now uses the request class to load content, missing documents are returned as XHTML 404 Web pages.
    //This causes a regression where an HTML document is returned instead of null. To bypass, the HTTP status and the content-type
    //can be used to better limit if an XML was actually located.  Since NOT returning a document is a restrictive
    //act, the conditional below attempts to load the document if any one of three conditions is met:
    // 1) running from the file system, 2) content-type contains the string, 'xml', or 3) the status code is 200-299
    var status = objReq.getStatus() + "";
    var strCT = objReq.getResponseHeader("content-type");
    if(jsx3.util.strEmpty(strCT) ? true : (/xml/i.test(strCT) || /^2[0-9]+[0-9]+/.test(status))) {
      this.loadXML(objReq.getResponseText());
    } else {
      //TODO: I want a different error message here
      this.setError(102, jsx3._msg("xml.doc_status", this._url, status));
    }
  };
  
  
  Document_prototype._onRequestEvent = function(objEvent) {
    var Request = jsx3.net.Request;
    var req = objEvent.target;
    var strSubject = objEvent.subject;

    req.unsubscribe("*", this, "_onRequestEvent");
    
    if (strSubject == Request.EVENT_ON_RESPONSE) {
      this._initFromReq(req);
    } else if (strSubject == Request.EVENT_ON_TIMEOUT) {
      this.setError(111, jsx3._msg("xml.timeout"));
      this.publish({subject:Document.ON_TIMEOUT});      
    } else {
      Document._log();
    }
  };

 if (jsx3.CLASS_LOADER.IE) {

  
  Document_prototype._initEntity = function(objElm) {
    Entity.prototype.init.call(this, objElm);

    var ns = [];
    var attr = this.getAttributeNames();
    for (var i = 0; i < attr.length; i++) {
      var a = attr[i];
      if (a.indexOf("xmlns:") == 0)
        ns[ns.length] = a + '="' + this.getAttribute(a) + '"';
    }
    this.setSelectionNamespaces(ns.join(" "));
  };
  
  
  Document_prototype.loadXML = function(strXML) {
    this._url = null;
    this.setError(0);

    try {

      var t1 = new jsx3.util.Timer(Document.jsxclass, strXML != null ? jsx3.util.strTruncate(strXML, 30) : "", 5);


      this._document.loadXML(strXML);

      if (! this._setErrorFromParser(this._document))
        this._initEntity(this._document.documentElement);


      t1.log("parse");

    } catch (e) {
      this._setErrorFromParser(this._document, jsx3.NativeError.wrap(e));
    }
    return this;
  };

 } else if (jsx3.CLASS_LOADER.SAF) {

  
  Document_prototype._initEntity = function(objElm) {
    Entity.prototype.init.call(this, objElm);
  };

  Document_prototype.loadXML = function(strXML) {
    this._url = null;
    this.setError(0);

    try {

      var t1 = new jsx3.util.Timer(Document.jsxclass, strXML != null ? jsx3.util.strTruncate(strXML, 30) : "", 5);


      this._document = (new DOMParser()).parseFromString(strXML, "text/xml");

      if (! this._setErrorFromParser(this._document))
        this._initEntity(this._document.documentElement);


      t1.log("parse");

    } catch (e) {
      this._setErrorFromParser(this._document, jsx3.NativeError.wrap(e));
    }

    return this;
  };

 } else if (jsx3.CLASS_LOADER.FX) {

  
  Document_prototype._initEntity = function(objElm) {
    Entity.prototype.init.call(this, objElm);
  };

  Document_prototype.loadXML = function(strXML) {
    this._url = null;
    this.setError(0);

    try {

      var t1 = new jsx3.util.Timer(Document.jsxclass, strXML != null ? jsx3.util.strTruncate(strXML, 30) : "", 5);


      this._document = (new DOMParser()).parseFromString(strXML, "text/xml");

      if (! this._setErrorFromParser(this._document))
        this._initEntity(this._document.documentElement);


      t1.log("parse");

    } catch (e) {
      this._setErrorFromParser(this._document, jsx3.NativeError.wrap(e));
    }

    return this;
  };

 }

  
  Document_prototype.getSourceURL = function() {
    return this._url;
  };

  
  Document_prototype._setErrorFromParser = function(parser, ex) {
    if (parser != null) {
      // QUESTION: I have no idea if this applies to Fx
      var parseError = parser.parseError;
      if (parseError != null && parseError.errorCode != "0") {
        var strMessage = jsx3._msg("xml.err_fmt", parseError.errorCode, parseError.line, parseError.linepos,
            jsx3.util.strTrim(String(parseError.reason)), jsx3.util.strTruncate(parseError.srcText), parseError.url);
        this.setError(parseError.errorCode, strMessage);
        return true;
      }
 if (jsx3.CLASS_LOADER.SAF) {
      var docElement = parser.documentElement;
      if (docElement == null) {
        if (ex)
          this.setError(156, jsx3._msg("xml.doc_bad_ex", ex));
        else
          this.setError(106, jsx3._msg("xml.doc_bad"));
        return true;
      } else {
        var xpe = new XPathEvaluator();
        var nsr = jsx3.CLASS_LOADER.GOG ?
                xpe.createNSResolver((new DOMParser()).parseFromString('<x xmlns:x="http://www.w3.org/1999/xhtml"/>', "text/xml")) :
                function(prefix) {
                  if (prefix == "x") return "http://www.w3.org/1999/xhtml";
                  return null;
                };

        var objResult = xpe.evaluate("//x:parsererror//x:div", parser, nsr);
        var descNode = objResult.iterateNext();
        if (descNode) {
          this.setError(107, descNode.textContent.replace(/[\n\r]/g, " "));
          return true;
        }
      }
 } else if (! jsx3.CLASS_LOADER.IE) {
      var docElement = parser.documentElement;
      if (docElement == null) {
        if (ex)
          this.setError(158, jsx3._msg("xml.doc_bad_ex", ex));
        else
          this.setError(108, jsx3._msg("xml.doc_bad"));
        return true;
      } else if (docElement.tagName == "parsererror" && docElement.namespaceURI &&
          docElement.namespaceURI.match(/^http:\/\/www\.mozilla\.org\/(.+\/)?parsererror.xml/i)) {
        this.setError(109, docElement.textContent.replace(/[\n\r]/g, " "));
        return true;
      }
 }
    }

    if (ex != null) {
      this.setError(110, jsx3._msg("xml.unknown", jsx3.NativeError.wrap(ex)));
      return true;
    }

    return false;
  };



  
  Document_prototype.getValidateOnParse = function() {
    //TO DO: validate the analagous method for fx
    return this._document.validateOnParse;
  };

  
  Document_prototype.setValidateOnParse = function(bValidate) {
    this._document.validateOnParse = bValidate;
  };

  
  Document_prototype.getResolveExternals = function() {
    //TO DO: validate the analagous method for fx
    return this._document.resolveExternals;
  };

  
  Document_prototype.setResolveExternals = function(bResolve) {
    this._document.resolveExternals = bResolve;
  };



 if (jsx3.CLASS_LOADER.IE) {

  Document_prototype.toString = function() {
    if (this._document != null && !this.hasError()) {
      var s = this._document.xml;
      // HACK: remove trailing line break to match Fx behavior
      if (s.charCodeAt(s.length - 1) == 10 && s.charCodeAt(s.length - 2) == 13)
        s = s.substring(0, s.length - 2);
      return s;
    } else {
      return this.jsxsuper();
    }
  };

  
  Document_prototype.getXmlVersion = function() {
    return this._getXmlDeclAttr("version");
  };

  
  Document_prototype.getXmlEncoding = function() {
    return this._getXmlDeclAttr("encoding");
  };

  
  Document_prototype.getXmlStandalone = function() {
    return this._getXmlDeclAttr("standalone") == "yes";
  };

  
  Document_prototype._getXmlDeclAttr = function(strAttr) {
    var pi = this._document.childNodes[0];
    if (pi.nodeType == 7 && pi.nodeName == "xml") {
      var regexp = new RegExp("\\b" + strAttr + '="(.*?)"', "i");
      if (pi.nodeValue.match(regexp))
        return RegExp.$1;
    }
    return null;
  };

  
  Document_prototype.cloneDocument = function() {
    return new Document(this._document.cloneNode(true));
  };

 } else if (jsx3.CLASS_LOADER.SAF) {

  Document_prototype.cloneDocument = function() {
    var clone = new Document();
    clone.loadXML(this.getXML());
    return clone;
  };

 } else {

  Document_prototype.cloneDocument = function() {
    try {
      netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
    } catch (e) {;}

    //I cannot track down why a synchronously loaded xsl doc with document.domain set in fx is throwing error
    try {
      var objDoc = new Document(this._document.cloneNode(true));
    } catch(e) {
      var objDoc = new Document();
      objDoc.loadXML(this.getXML());
    }
    return objDoc;
  };

 }

 if (! jsx3.CLASS_LOADER.IE) {

  Document_prototype.toString = function() {
    if (this._document != null && !this.hasError()) {
      return (new XMLSerializer()).serializeToString(this._document);
    } else {
      return this.jsxsuper();
    }
  };

  Document_prototype.getXmlVersion = function() {
    return this._document.xmlVersion;
  };

  Document_prototype.getXmlEncoding = function() {
    return this._document.xmlEncoding;
  };

  Document_prototype.getXmlStandalone = function() {
    return this._document.xmlStandalone;
  };

 }

  
  Document_prototype.serialize = function(strVersion, strEncoding, bStandalone) {
    if (strVersion === true) strVersion = this.getXmlVersion() || "1.0";
    if (strEncoding === true) strEncoding = this.getXmlEncoding();

    var clobberPI = strVersion || strEncoding || bStandalone;

    if (clobberPI) {
      var pi = '<?xml';
      if (strVersion) pi += ' version="' + strVersion + '"';
      if (strEncoding) pi += ' encoding="' + strEncoding + '"';
      if (bStandalone != null) pi += ' standalone="' + (bStandalone ? "yes" : "no") + '"';
      pi += '?>\n';

      var tokens = new Array(this._document.childNodes.length + 1);
      tokens[0] = pi;

      for (var i = 0; i < this._document.childNodes.length; i++) {
        var node = this._document.childNodes[i];
        if (node.nodeType != 7 || node.nodeName != "xml") {
          var wrapped = new Entity(node);
          tokens[i+1] = wrapped.hasError() ? "<!-- " + wrapped + " -->" : wrapped.toString();
        }
      }
    } else {
      var tokens = new Array(this._document.childNodes.length);

      for (var i = 0; i < this._document.childNodes.length; i++) {
        var node = this._document.childNodes[i];
        var wrapped = new Entity(node);
        tokens[i] = wrapped.hasError() ? "<!-- " + wrapped + " -->" : wrapped.toString();
        if (node.nodeType == 7 || node.nodeName == "xml")
          tokens[i] += "\n";
      }
    }

    return tokens.join("");
  };

  
  Document_prototype.createDocumentElement = function(strNodeName, strNSURI) {
 if (jsx3.CLASS_LOADER.IE) {
    if (strNSURI) {
      var objRoot = this._document.createNode(jsx3.xml.Entity.TYPEELEMENT,strNodeName,strNSURI);
    } else {
      var objRoot = this._document.createElement(strNodeName);
    }
 } else {
    // NOTE: see http://bugs.webkit.org/show_bug.cgi?id=14835
    if (strNSURI == null) strNSURI = null;
    var objRoot = this._document.createElementNS(strNSURI, strNodeName);
 }

    if (this._document.documentElement != null)
      this._document.replaceChild(objRoot, this._document.documentElement);
    else
      this._document.appendChild(objRoot);

    //bind expected references to the root node as the jsx3.xml.Document class implements the methods of the jsx3.xml.Entity class, meaning all methods that one can expect from the jsx3.xml.Entity class should apply to this class as well
    this._initEntity(this._document.documentElement);

    //return wrapped node
    return (new jsx3.xml.Entity(objRoot));
  };

  
  Document_prototype.createProcessingInstruction = function(strTarget, strData) {
    // TODO: Mozilla
    //create, append, and wrap
    var objRoot = this._document.createProcessingInstruction(strTarget, strData);
    this._document.appendChild(objRoot);
  };

  
  Document_prototype.setAsync = function(bAsync) {
    
    this._jsxasync = bAsync;
    return this;
  };

  
  Document_prototype.getAsync = function(strName) {
    return Boolean(this._jsxasync);
  };


  
  
  Document_prototype.setSelectionLanguage = function(strLanguage) {
 if (jsx3.CLASS_LOADER.IE) {
    this._document.setProperty("SelectionLanguage", strLanguage);
 }
    return this;
  };

  
  Document_prototype.getSelectionLanguage = function() {
 if (jsx3.CLASS_LOADER.IE) {
    return this._document.getProperty("SelectionLanguage");
 } else {
    return "XPath";
 }
  };


  
  
  Document.serializeNamespacesMap = function(map) {
    var a = [];
    for (var p in map)
      a[a.length] = "xmlns:" + map[p] + "='" + p + "'";
    return a.join(" ");
  };

  
  Document_prototype.setSelectionNamespaces = function(declaration) {
    //convert object to string (per IE format constraints)
    if(typeof(declaration) == "object") declaration = Document.serializeNamespacesMap(declaration);

 if (jsx3.CLASS_LOADER.IE) {
    try {
      this._document.setProperty("SelectionNamespaces", declaration);
    } catch (e) {
      this.setError(113, jsx3._msg("xml.selns", declaration, jsx3.NativeError.wrap(e)));
    }
 } else {
    this._document._jsxselectionns = declaration;
    this._document._jsxselectionnsobj = null;
 }
    return this;
  };

  
  Document_prototype.getSelectionNamespaces = function(strName) {
 if (jsx3.CLASS_LOADER.IE) {
    return this._document.getProperty("SelectionNamespaces");
 } else {
    //3.2 fix: updated signature to return empty string in FF as would be returned in IE
    return (this._document._jsxselectionns) ? this._document._jsxselectionns : "";
 }
  };

  
  Document_prototype.createNamespaceAxis = function() {
    var objNode = this.getRootNode();
    var strXML = objNode.toString();
    var intIncr = "";
    do {
      var re = new RegExp("xmlns:" + Document.SEARCHABLE_PREFIX + intIncr + "([^=]*)=['\"]([^\"^']*)['\"]","g");
      var intPos = strXML.search(re);
      if(intPos >= 0) intIncr = (intIncr == "") ? 0 : intIncr + 1;
    } while(intPos >= 0);

    this._createNamespaceAxis(objNode,Document.SEARCHABLE_PREFIX + intIncr);

 if (! jsx3.CLASS_LOADER.IE) {
    //how to add a new namespace???? reparse to commit...
    this.loadXML(this.getXML());
 }

    return Document.SEARCHABLE_PREFIX + intIncr;
  };

  
  Document_prototype._createNamespaceAxis = function(objElement,strPre) {
    //get the entity as string without descendants
    var strXML = objElement.cloneNode(false).getXML();

    //parse out all instances of the 'namespace' (xmlns) axis, and create a searchable equivalent belonging to the 'attribute' namespace
    var myArr;
    while(myArr = Document.SEARCHABLE_REGEXP.exec(strXML)) {
      if(RegExp.$1 != strPre && RegExp.$1 != "xml") {
        var objAtt = objElement.createNode( jsx3.xml.Entity.TYPEATTRIBUTE, (strPre + ":" + RegExp.$1), Document.SEARCHABLE_NAMESPACE);
        objAtt.setValue(RegExp.$2);
        objElement.setAttributeNode(objAtt);
      } else if( RegExp.$1 == "xml") {
        jsx3.log(strXML);
      }
    }

    //recurse to locate other xmlns declarations among descendant elements
    for (var i = objElement.getChildIterator(); i.hasNext(); )
      this._createNamespaceAxis(i.next(), strPre);
  };

  
  Document_prototype.getDeclaredNamespaces = function(objMap) {
    //reset the hash
    this._jsx_sn_hash = {};

    //get the root (start point)
    var objNode = this.getRootNode();
    if(objNode) this._getDeclaredNamespaces(objNode,{index:0},objMap);

    //return the final map (user can use to resolve namespaces with--effectively creates a QName)
    return this._jsx_sn_hash;
  };

  
  Document_prototype._getDeclaredNamespaces = function(objNode,oCounter,objMap) {
    //add a new namespace if unique
    var sQ = objNode.getNamespaceURI();
    if(sQ != "" && sQ != "http://www.w3.org/XML/1998/namespace") {
      var mypfx;
      if(!this._jsx_sn_hash[sQ] || (objMap && (mypfx = objNode.getPrefix()) != "" && typeof(objMap[mypfx]) != "undefined")) {
        if(mypfx) {
          this._jsx_sn_hash[sQ] = mypfx;
        } else {
          oCounter.index += 1;
          this._jsx_sn_hash[sQ] = "jsx" + oCounter.index;
        }
      }
    }

    //recurse if objNode is an element
    if (objNode.getNodeType() == jsx3.xml.Entity.TYPEELEMENT) {
      for (var i = objNode.selectNodeIterator("attribute::* | child::*"); i.hasNext(); ) {
        var objChild = i.next();
        if (objChild.getNodeType() == jsx3.xml.Entity.TYPEELEMENT ||
            objChild.getNodeType() == jsx3.xml.Entity.TYPEATTRIBUTE)
          this._getDeclaredNamespaces(objChild, oCounter, objMap);
      }
    }
  };

  
  Document_prototype.getNativeDocument = function() {
    //returns the xml parser instance
    return this._document;
  };

  
  Document._log = function(intLevel, strMessage) {
    if (Document._LOG == null) {
      if (jsx3.util.Logger) {
        
        Document._LOG = jsx3.util.Logger.getLogger(Document.jsxclass.getName());
        if (Document._LOG == null) return;
      } else {
        return;
      }
    }
    Document._LOG.log(intLevel, strMessage);
  };



  
  Document.getVersion = function() {
    return "3.0.0";
  };



});




jsx3.Document = jsx3.xml.Document;


