

// @jsxobf-clobber-shared  _EP _PERM _jsxselectionns _jsxselectionnsobj serializeNamespacesMap


jsx3.Class.defineClass("jsx3.xml.Entity", null, null, function(Entity, Entity_prototype) {

  
  Entity.TYPEELEMENT = 1;

  
  Entity.TYPEATTRIBUTE = 2;

  
  Entity.TYPETEXT = 3;

  
  Entity.TYPECDATA = 4;

  
  Entity.TYPECOMMENT = 8;

  
  Entity._SUPPORTED = {1:true, 2:true, 3:true, 4:true, 7:true, 8:true};

  
  Entity_prototype.init = function(objEntity) {
    //bind reference to the MSXML parser node that this classes APIs will wrap
    
    this._entity = objEntity;

    //for now only types 1 - 4 are supported
    
    this._nodeType = objEntity.nodeType;

    //check the type of entity - if not valid modify the error object
    if (!(Entity._SUPPORTED[this._nodeType])) {
      this.setError(300, jsx3._msg("xml.wrap_type", this._nodeType));
    } else if (this._error) {
      this.setError(0);
    }
  };

  
  Entity_prototype.createNode = function(intType, strNodeName, strNS) {
    //get handle to the document object (this has the ability to create nodes)
    var objDoc = this._getNativeDoc();
    var objNode = null;

 if (jsx3.CLASS_LOADER.IE) {
    if (strNS == null) strNS = "";
    if (intType == 3) {
      objNode = objDoc.createTextNode(strNodeName);
    } else if (intType == 4) {
      objNode = objDoc.createCDATASection(strNodeName);
    } else if (intType == 8) {
      objNode = objDoc.createComment(strNodeName);
    } else {
      objNode = objDoc.createNode(intType, strNodeName, strNS);
    }
 } else {
    // NOTE: see http://bugs.webkit.org/show_bug.cgi?id=14835
    if (strNS == null) strNS = null;
    if (intType == 2) {
      objNode = objDoc.createAttributeNS(strNS, strNodeName);
    } else if (intType == 3) {
      objNode = objDoc.createTextNode(strNodeName);
    } else if (intType == 4) {
      objNode = objDoc.createCDATASection(strNodeName);
    } else if (intType == 8) {
      objNode = objDoc.createComment(strNodeName);
    } else {
      objNode = objDoc.createElementNS(strNS, strNodeName);
    }
 }

    //return wrapped node
    return new Entity(objNode);
  };

  
  Entity_prototype.cloneNode = function(bDeep) {
    //make sure our wrapped node isn't null and user is passing the correct object type
    if (this._nodeType == 1) {
      var objMSXMLNode = this._entity.cloneNode(bDeep);
      return (new Entity(objMSXMLNode));
    } else {
      this.setError(301, jsx3._msg("xml.clone_tp", this._nodeType));
    }
  };

  
  Entity_prototype.appendChild = function(objEntity) {
    var e = objEntity._entity;
 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
    var docChange = e.ownerDocument != this._entity.ownerDocument;
    if (docChange) e = this._entity.ownerDocument.importNode(e, true);
 }

    //make sure our wrapped node isn't null and user is passing the correct object type
    if (this._entity != null && e != null && this._nodeType == 1) {
      this._entity.appendChild(e);

 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
      if (docChange && objEntity._entity.parentNode)
        objEntity._entity.parentNode.removeChild(objEntity._entity);
      objEntity._entity = e;
 }
    } else {
      this.setError(302, jsx3._msg("xml.err_append", objEntity));
    }
    return this;
  };

  
  Entity_prototype.insertBefore = function(objEntityNew, objEntityRef) {
    if (objEntityRef == null) {
      if (this._nodeType == 1) {
        this.appendChild(objEntityNew);
        return objEntityNew;
      }
    } else {
      var e = objEntityNew._entity;
 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
      var docChange = e.ownerDocument != this._entity.ownerDocument;
      if (docChange) e = this._entity.ownerDocument.importNode(e, true);
 }

      if (this._nodeType == 1 && objEntityRef._nodeType != 2 && objEntityNew._nodeType != 2) {
        if (objEntityRef.getParent() != null && objEntityRef.getParent().equals(this)) {
          var retVal = (new Entity(this._entity.insertBefore(e, objEntityRef._entity)));

 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
          if (docChange && objEntityNew._entity.parentNode) {
            objEntityNew._entity.parentNode.removeChild(objEntityNew._entity);
          }
          objEntityNew._entity = e;
 }

          return retVal;
        }
      }
      return null;
    }
  };

  
  Entity_prototype.replaceNode = function(objEntityNew, objEntityOld) {
    var e = objEntityNew._entity;
 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
    var docChange = e.ownerDocument != this._entity.ownerDocument;
    if (docChange) e = this._entity.ownerDocument.importNode(e, true);
 }

    if (this._nodeType == 1 && objEntityOld._nodeType == 1 && objEntityNew._nodeType == 1) {
      if (objEntityOld.getParent() != null && objEntityOld.getParent().equals(this) && objEntityOld.getParent() != null && objEntityOld.getParent().equals(this)) {
        var retVal = (new Entity(this._entity.replaceChild(e, objEntityOld._entity)));

 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
        if (docChange && objEntityNew._entity.parentNode)
          objEntityNew._entity.parentNode.removeChild(objEntityNew._entity);
        objEntityNew._entity = e;
 }

        return retVal;
      }
    }
    return null;
  };

  
  Entity_prototype.setAttribute = function(strName, strValue) {
    //make sure our wrapped node isn't null and user is passing the correct object type
    if (strValue != null)
      // HACK: IE's XML conversion to String is incompatible with JavaScript, so explicit String conversion
      this._entity.setAttribute(strName, String(strValue));
    else
      this.removeAttribute(strName);
    return this;
  };

  
  Entity_prototype.getAttribute = function(strName) {
    //return as simple string; no need to wrap
    return this._entity ? this._entity.getAttribute(strName) : null;
  };

  
  Entity_prototype.getAttributeNode = function(strName) {
    //make sure our wrapped node isn't null and user is passing the correct object type
    if (this._entity != null && this._nodeType == 1) {
      var objAtt = this._entity.getAttributeNode(strName);
      if (objAtt != null) return (new Entity(objAtt));
    }
  };

  
  Entity_prototype.setAttributeNode = function(objAtt) {
    var e = objAtt._entity;
 if (jsx3.CLASS_LOADER.SAF) {
    //3.6:  LUKE:  Removed FX from the conditional above:   (|| jsx3.CLASS_LOADER.FX)
    //             This same code worked in Fx 1.5 and 2.  I believe the transformiix processor was updated in all versions
    //             Validate against Fx release notes for both hot fixes and major releases to see if this should be changed or additional
    //             Firefox exceptions need to be noted per version, release, etc
    //I cannot find public DOM methods for setting the namespace as an axis (not attribute); there has to be something (or is this a bug to file for them)
    if(!jsx3.util.strEmpty(objAtt.getPrefix()))
      this.setAttribute("xmlns:" + objAtt.getPrefix(),objAtt.getNamespaceURI());
 }

   if (jsx3.CLASS_LOADER.SAF  || jsx3.CLASS_LOADER.FX) {
     var docChange = e.ownerDocument != this._entity.ownerDocument;
    if (docChange) {
      e = this._entity.ownerDocument.createAttribute(e.nodeName);
      e.nodeValue = objAtt._entity.nodeValue;
      objAtt._entity = e;
    }
 }

 if (jsx3.CLASS_LOADER.IE) {
    this._entity.setAttributeNode(e);
 } else {
    this._entity.setAttributeNodeNS(e);
 }
    return this;
  };

  
  Entity_prototype.getAttributes = function() {
    //make sure our wrapped node isn't null and user is passing the correct object type
    if (this._entity != null && this._nodeType == 1)
      return new Entity.List(this._entity.attributes);
    else
      return null;
  };

  
  Entity_prototype.getAttributeNames = function() {
    var att = this._entity.attributes;
    var names = new Array(att.length);
    for (var i = 0; i < names.length; i++)
      names[i] = att[i].nodeName;
    return names;
  };

  
  Entity_prototype.getRootNode = function() {
    return this._entity ? (new Entity(this._getNativeDoc(1))) : null;
  };

  
  Entity_prototype.getParent = function() {
    //return the parent ref; return null if na
    return (this._entity != this._getNativeDoc(1)) ? (new Entity(this._entity.parentNode)) : null;
  };

  
  Entity_prototype.getChildIterator = function(bIncludeText) {
    return new Entity.ChildIterator(this._entity ? this._entity.childNodes : [], bIncludeText);
  };

  
  Entity_prototype.getChildNodes = function(bIncludeText) {
    if (! this._entity) return new Entity.List([]);
    var nodes = this._entity.childNodes;
    var children = [];
    for (var i = 0; i < nodes.length; i++) {
      var node = nodes[i];
      if (node.nodeType == 1 ||
          (bIncludeText && (node.nodeType == 3 || node.nodeType == 4)))
        children[children.length] = node;
    }
    return new Entity.List(children);
  };

  
  Entity_prototype.removeChild = function(objChildEntity) {
    //make sure acutal parent according to native relationships
    var p = objChildEntity.getParent();
    return p != null && p.equals(this) ?
        new Entity(this._entity.removeChild(objChildEntity._entity)) : null;
  };

  
  Entity_prototype.removeChildren = function() {
    var children = this._entity.childNodes;
    for (var i = children.length - 1; i >= 0; i--) {
      this._entity.removeChild(children[i]);
    }
  };

  
  Entity_prototype.removeAttribute = function(strAttName) {
    //make sure acutal parent according to native relationships
    if (this._nodeType == 1) this._entity.removeAttribute(strAttName);
  };

  
  Entity_prototype.removeAttributeNode = function(objAtt) {
    this._entity.removeAttributeNode(objAtt._entity);
    return this;
  };

  
  Entity_prototype.equals = function(objEntity) {
    //make sure acutal parent according to native relationships
    return (objEntity._entity == this._entity);
  };

  
  Entity_prototype.getNodeType = function() {
    //nodeType was set at instantiation and can be referenced as a property on this JS class directly
    return this._nodeType;
  };

  
  Entity_prototype.getNodeName = function() {
    return this._entity.nodeName;
  };

  
  Entity_prototype.getNamespaceURI = function() {
    //return as simple string; no need to wrap
    //TO DO: there seeems to be an inconsistency with the signature in firefox (bugzilla). make sure an empty string is returned
    var sns = this._entity.namespaceURI;
    if(sns == null) sns = "";
    return sns;
  };

  
  Entity_prototype.selectSingleNode = function(strQuery, strNS) {
    if (! this._entity) return null;
    return this._selectNodeOrNodes(strQuery, strNS, 0);
  };

  
  Entity_prototype.selectNodes = function(strQuery, strNS) {
    if (! this._entity) return new Entity.List([]);
    return this._selectNodeOrNodes(strQuery, strNS, 1);
  };

  
  Entity_prototype.selectNodeIterator = function(strQuery, strNS) {
    if (! this._entity) return new Entity.SelectIterator();
    return this._selectNodeOrNodes(strQuery, strNS, 2);
  };

 if (jsx3.CLASS_LOADER.IE) {

  
  Entity_prototype.getBaseName = function() {
    //return as simple string; no need to wrap
    return this._entity.baseName;
  };

  
  Entity_prototype.getPrefix = function() {
    //return as simple string; no need to wrap
    return this._entity.prefix;
  };

  
  Entity_prototype.getXML = function() {
    return this._entity.xml;
  };

  
  Entity_prototype.toString = function() {
    var typeToken = "@" + this.getClass().getName();
    if (this._entity != null && !this.hasError()) {
      return (this._entity.xml) ? this._entity.xml :
          (this._entity.outerHTML ? this._entity.outerHTML : jsx3._msg("xml.str_unk", typeToken));
    } else {
      return this.hasError() ?
          jsx3._msg("xml.str_err", typeToken, this.getError()) :
          jsx3._msg("xml.str_empty", typeToken);
    }
  };

  
  Entity_prototype.getValue = function() {
    return (this._nodeType == 1) ? this._entity.text : this._entity.nodeValue;
  };

  
  Entity_prototype.setValue = function(strValue) {
    if (strValue == null) strValue = "";
    else strValue = String(strValue);
    
    if (this._nodeType == 1) {
      this._entity.text = strValue;
    } else {
      this._entity.nodeValue = strValue;
    }
    return this;
  };

  
  Entity_prototype._selectNodeOrNodes = function(strQuery, strNS, intMode) {
    if (typeof(strNS) == "object") strNS = jsx3.xml.Document.serializeNamespacesMap(strNS);

    //resolve the declaration as a selection namespace
    var strPrevNS, objDoc = null;
    if (strNS != null) {
      objDoc = this._entity.ownerDocument;
      strPrevNS = objDoc.getProperty("SelectionNamespaces");
      objDoc.setProperty("SelectionNamespaces", strNS);
    }

    var retVal = null, objNodes;
    if (intMode) {
      try {
        objNodes = this._entity.selectNodes(strQuery);
      } catch (e) {
        objNodes = [];
      }
      retVal = intMode == 2 ? new Entity.SelectIterator(objNodes) : new Entity.List(objNodes);
    } else {
      try {
        var objNode = this._entity.selectSingleNode(strQuery);
      } catch (e) {;}
      retVal = objNode ? new Entity(objNode) : null;
    }

    if (objDoc) objDoc.setProperty("SelectionNamespaces", strPrevNS);
    
    return retVal;
  };

 } else {

  Entity_prototype.getBaseName = function() {
    //return as simple string; no need to wrap
    var strNodeName = this.getNodeName();
    var index = strNodeName.indexOf(":");
    return index >= 0 ? strNodeName.substring(index+1) : strNodeName;
  };

  Entity_prototype.getPrefix = function() {
    //return as simple string; no need to wrap
    var strNodeName = this.getNodeName();
    var index = strNodeName.indexOf(":");
    return index >= 0 ? strNodeName.substring(0, index) : "";
  };

  Entity_prototype.getXML = function() {
    return this.toString();
  };

  Entity_prototype.toString = function() {
    var typeToken = "@" + this.getClass().getName();

    if (this._entity != null && !this.hasError()) {
      if (this.getNodeType() == 2) {
        return this.getNodeName() + '="' + this.getValue() + '"';
      } else {
        return (new XMLSerializer()).serializeToString(this._entity);
      }
    } else {
      return this.hasError() ?
          jsx3._msg("xml.str_err", typeToken, this.getError()) :
          jsx3._msg("xml.str_empty", typeToken);
    }
  };

  Entity_prototype.getValue = function() {
    if (this._nodeType == 1) {
      var tokens = new Array(this._entity.childNodes.length);
      for (var i = 0; i < this._entity.childNodes.length; i++) {
        var child = this._entity.childNodes[i];
        if (child.nodeType == Entity.TYPETEXT || child.nodeType == Entity.TYPECDATA)
          tokens[i] = child.nodeValue;
        else
          tokens[i] = child.textContent;
      }
      return tokens.join("");
    } else {
      return this._entity.nodeValue;
    }
  };

  Entity_prototype.setValue = function(strValue) {
    if (strValue == null) strValue = "";
    if (this._nodeType == 1) {
      this.removeChildren();
      this.appendChild(this.createNode(3, strValue));
    } else {
      this._entity.nodeValue = strValue;
    }
    return this;
  };

  
  Entity._XPE = new XPathEvaluator();
  
  Entity._RESULT_TYPES = [XPathResult.FIRST_ORDERED_NODE_TYPE,
      XPathResult.ORDERED_NODE_ITERATOR_TYPE,
      XPathResult.ORDERED_NODE_SNAPSHOT_TYPE];

  
  Entity_prototype._selectNodeOrNodes = function(strQuery, strNS, intMode) {
    if (typeof(strNS) == "object") strNS = jsx3.xml.Document.serializeNamespacesMap(strNS);

    var doc = this._entity.ownerDocument;
    var root = doc.documentElement;
    var nsResolver = strNS ? Entity._createNSResolver(strNS, root) :
        (Entity._getDocNSResolver(doc) || Entity._XPE.createNSResolver(root));

    var objResult = null;
    try {
      objResult = Entity._XPE.evaluate(strQuery, this._entity, nsResolver, Entity._RESULT_TYPES[intMode], null);
    } catch (e) {
      ; // QUESTION: what if this is a real error?
    }

    if (intMode == 1) {
      var itm = null;
      var objNodes = [];
      if (objResult)
        while (itm = objResult.iterateNext()) objNodes[objNodes.length] = itm;

      return new Entity.List(objNodes);
    } else if (intMode == 2) {
      return new Entity.SelectIterator(objResult);
    } else {
      return objResult && objResult.singleNodeValue ? new Entity(objResult.singleNodeValue) : null;
    }
  };

  
  Entity._getDocNSResolver = function(doc) {
    if (! doc._jsxselectionnsobj) {
      if (doc._jsxselectionns)
        doc._jsxselectionnsobj = Entity._createNSResolver(doc._jsxselectionns);
    }
    return doc._jsxselectionnsobj;
  };

  
  Entity._nsResCache = {}; // TODO: limit the size of this cache

  
  Entity._createNSResolver = function(ns) {
    var resolver = Entity._nsResCache[ns];
    if (!resolver) {
      var nsDoc = (new DOMParser()).parseFromString('<foo ' + ns + '/>', "text/xml");
      resolver = Entity._nsResCache[ns] = Entity._XPE.createNSResolver(nsDoc.documentElement);
    }
    return resolver;
  };

 }

  
  Entity_prototype._getNativeDoc = function(intType) {
    if (intType == null) {
      return this._entity.ownerDocument;
    } else if (intType == 1) {
      var doc = this._entity.ownerDocument;
      return doc != null ? doc.documentElement : null;
    } else if (intType == 2) {
      return this._entity.documentElement;
    }
  };

  
  Entity_prototype.getNative = function() {
    //returns the entire MSXML instance
    return this._entity;
  };

  
  Entity_prototype.getFirstChild = function() {
    if (this._nodeType == 1) {
      var objNode = this._entity.firstChild;

      // only return elements
      while (objNode != null && objNode.nodeType != 1)
        objNode = objNode.nextSibling;

      if (objNode != null) return (new Entity(objNode));
    }
    return null;
  };

  
  Entity_prototype.getLastChild = function() {
    if (this._nodeType == 1) {
      var objNode = this._entity.lastChild;

      // only return elements
      while (objNode != null && objNode.nodeType != 1)
        objNode = objNode.previousSibling;

      if (objNode != null) return (new Entity(objNode));
    }
    return null;
  };

  
  Entity_prototype.getPreviousSibling = function() {
    if (this._nodeType == 1) {
      var objNode = this._entity.previousSibling;

      // only return elements
      while (objNode != null && objNode.nodeType != 1)
        objNode = objNode.previousSibling;

      if (objNode != null) return (new Entity(objNode));
    }
    return null;
  };

  
  Entity_prototype.getNextSibling = function() {
    if (this._nodeType == 1) {
      var objNode = this._entity.nextSibling;

      // only return elements
      while (objNode != null && objNode.nodeType != 1)
        objNode = objNode.nextSibling;

      if (objNode != null) return (new Entity(objNode));
    }
    return null;
  };

  
  Entity_prototype.transformNode = function(objEntityFilter, objParams, bObject) {
    jsx3.require("jsx3.xml.Template");
    var t = new jsx3.xml.Template(objEntityFilter);
    if (objParams) t.setParams(objParams);
    return t[bObject ? "transformToObject" : "transform"](this);
  };

  
  Entity._Error = function() {};
  Entity._Error.prototype.toString = function() {
    return "[" + this.code + "]" + (typeof(this.description) != "undefined" ? " " + this.description : "");
  };

  
  Entity_prototype.setError = function(strCode, strDescription) {
    if (this._error == null) {
      
      this._error = new Entity._Error();
    }
    this._error.code = strCode;
    this._error.description = strDescription;
  };

  
  Entity_prototype.getError = function() {
    if (!this._error) this.setError(0);
    return this._error;
  };

  
  Entity_prototype.hasError = function() {
    return this._error != null && this._error.code != 0;
  };

  
  Entity_prototype.getOwnerDocument = function() {
    return this._entity ? new jsx3.xml.Document(this._getNativeDoc()) : null;
  };



  
  Entity.getVersion = function() {
    return "3.0.0";
  };



});




jsx3.Entity = jsx3.xml.Entity;




jsx3.Class.defineClass("jsx3.xml.Entity.List", jsx3.util.List, null, function(List, List_prototype) {

  var Exception = jsx3.Exception;

  List_prototype.init = function(arrSrc) {
    this.jsxsuper(null, true);
    
    this._src = arrSrc; // some node lists are not instanceof Array
  };

  List_prototype.get = function(intIndex) {
    var o = this._src[intIndex];
    return o != null ? new jsx3.xml.Entity(o) : o;
  };

  var exMessage = "Not implemented";
  List_prototype.add = function() { throw new Exception(exMessage); };
  List_prototype.addAll = function() { throw new Exception(exMessage); };
  List_prototype.set = function() { throw new Exception(exMessage); };
  List_prototype.remove = function() { throw new Exception(exMessage); };
  List_prototype.removeAt = function() { throw new Exception(exMessage); };
  List_prototype.sort = function() { throw new Exception(exMessage); };

  List_prototype.slice = function(intStart, intEnd) {
    return new List(arguments.length > 1 ? this._src.slice(intStart, intEnd) : this._src.slice(intStart));
  };

  List_prototype.toString = function() {
    return "[" + this.toArray() + "]";
  };

  List_prototype.clone = function() {
    return new List(this._src.concat());
  };

  List_prototype.toArray = function() {
    var size = this.size();
    var a = new Array(size);
    for (var i = 0; i < size; i++)
      a[i] = this.get(i);
    return a;
  };

});

// @jsxobf-clobber  _nodes _index _text _prepNext _entity


jsx3.Class.defineClass("jsx3.xml.Entity.ChildIterator", null, [jsx3.util.Iterator], function(Iterator, Iterator_prototype) {

  Iterator_prototype.init = function(arrChildren, bText) {
    this._nodes = arrChildren;
    this._index = 0;
    this._text = bText;
    this._prepNext();
    this._entity = null;
  };

  Iterator_prototype.next = function() {
    if (!this._next) return null;

    if (this._entity) {
      this._entity.init(this._next);
    } else {
      this._entity = new jsx3.xml.Entity(this._next);
    }
    this._prepNext();
    return this._entity;
  };

  Iterator_prototype.hasNext = function() {
    return this._next != null;
  };

  Iterator_prototype._prepNext = function() {
    this._next = null;
    var nodes = this._nodes;
    var max = nodes.length;
    while (this._next == null && this._index < max) {
      var node = nodes[this._index];
      if (node.nodeType == 1 || (this._text && (node.nodeType == 3 || node.nodeType == 4)))
        this._next = node;
      this._index++;
    }
  };

});

// @jsxobf-clobber  _i _n _entity


jsx3.Class.defineClass("jsx3.xml.Entity.SelectIterator", null, [jsx3.util.Iterator], function(Iterator, Iterator_prototype) {

  Iterator_prototype.init = function(i) {
    this._i = i;
    this._n = 0;
    this._entity = null;
  };

 if (jsx3.CLASS_LOADER.IE) {

  Iterator_prototype.next = function() {
    var next = this._i[this._n++];
    if (!next) return null;

    if (this._entity) {
      this._entity.init(next);
    } else {
      this._entity = new jsx3.xml.Entity(next);
    }

    return this._entity;
  };

  Iterator_prototype.hasNext = function() {
    return this._i && this._n < this._i.length;
  };

 } else {

  Iterator_prototype.next = function() {
    var next = this._i.snapshotItem(this._n++);
    if (!next) return null;
    
    if (this._entity) {
      this._entity.init(next);
    } else {
      this._entity = new jsx3.xml.Entity(next);
    }

    return this._entity;
  };

  Iterator_prototype.hasNext = function() {
    return this._i && this._n < this._i.snapshotLength;
  };

 }

});




jsx3.Collection = jsx3.xml.Entity.List;


jsx3.util.Collection = jsx3.Collection;


