

// @jsxobf-clobber-shared  setError


jsx3.Class.defineClass("jsx3.xml.Template", null, null, function(Template, Template_prototype) {

  
  Template.DISABLE_OUTPUT_ESCAPING = 1;

  
  Template._SUPPORTS = {};

 if (jsx3.CLASS_LOADER.IE) {
  Template._SUPPORTS[Template.DISABLE_OUTPUT_ESCAPING] = true;
 } else {
 }

  
  Template.supports = function(strKey) {
    return Template._SUPPORTS[strKey] || Boolean(0);
  };

  
  Template_prototype.init = function(objXSL) {
    if (objXSL.hasError())
      throw new jsx3.Exception(jsx3._msg("temp.init_err", objXSL.getError()));

 if (jsx3.CLASS_LOADER.IE) {

    if (objXSL.getBaseName() == "stylesheet") {
      try {
        // HACK: there is no way to remove a parameter from an IE template ... who writes their APIs?!?
        // so just cache the default values here so we can set them all explicitly when reset() is called
        
        this._pdef = {};
        for (var i = objXSL.selectNodeIterator("/xsl:stylesheet/xsl:param"); i.hasNext(); ) {
          var n = i.next();
          this._pdef[n.getAttribute("name")] = n.getValue();
        }

        //create the template (compiled XSLT store that facilitates parameter passing, improved performance)
        var msXSLT = jsx3.getXslInstance();
        msXSLT.stylesheet = objXSL.getNativeDocument();
        
        this._processor = msXSLT.createProcessor();
      } catch (e) {
        this.setError(200, jsx3._msg("temp.nat_err", jsx3.NativeError.wrap(e)));
      }
    } else {
      this.setError(201, jsx3._msg("temp.root_elm"));
    }

 } else {

    if (objXSL.getBaseName() == "stylesheet") {
      try {
        
        this._processor = new XSLTProcessor();
        this._processor.importStylesheet(objXSL.getNativeDocument());
      } catch (e) {
        this.setError(202, jsx3._msg("temp.nat_err", jsx3.NativeError.wrap(e)));
      }
    } else {
      this.setError(201, jsx3._msg("temp.root_elm"));
    }

    this._src = objXSL.getSourceURL();
 }
  };

 if (jsx3.CLASS_LOADER.IE) {

  
  Template_prototype.setParam = function(strName, objValue) {
    if (! this._params) this._params = new jsx3.util.List();
    if (this._params.indexOf(strName) < 0) this._params.add(strName);
    this._processor.addParameter(strName, objValue != null ? objValue.toString() : "");
  };

  
  Template_prototype._transform = function(objXML, bObject) {

    var t1 = new jsx3.util.Timer(Template.jsxclass, (objXML instanceof jsx3.xml.Document ? objXML.getSourceURL() : "") + " => " + this);


    this._processor.input = objXML instanceof jsx3.xml.Document ? objXML.getNativeDocument() : objXML.getNative();
    //transform and get the output
    this._processor.transform();
    var retVal = bObject ? (new jsx3.xml.Document()).loadXML(this._processor.output) : this._processor.output;

    // clean up, needed?
    this._processor.input = null;


    t1.log("transform");

    return retVal;
  };

  
  Template_prototype.reset = function() {
    for (var f in this._pdef)
      this._processor.addParameter(f, this._pdef[f]);
  };

 } else {

  Template_prototype.setParam = function(strName, objValue) {
    if (! this._params) this._params = new jsx3.util.List();
    if (this._params.indexOf(strName) < 0) this._params.add(strName);
    this._processor.setParameter("", strName, objValue != null ? objValue.toString() : "");
  };

  
  Template_prototype._transform = function(objXML, bObject) {

    var t1 = new jsx3.util.Timer(Template.jsxclass, (objXML instanceof jsx3.xml.Document ? objXML.getSourceURL() : "") + " => " + this);


    var nativeNode = objXML instanceof jsx3.xml.Document ? objXML.getNativeDocument() : objXML.getNative();
    var objDoc = this._processor.transformToDocument(nativeNode);

    var retVal = null;
    if (objDoc) {
      retVal = bObject ? new jsx3.xml.Document(objDoc) : (new XMLSerializer()).serializeToString(objDoc);
    } else {
      this.setError(203, jsx3._msg("temp.empty"));
    }


    t1.log("transform");

    return retVal;
  };

  Template_prototype.reset = function() {
    if (this._params) {
      for (var i = this._params.iterator(); i.hasNext(); )
        this._processor.removeParameter("", i.next());
      this._params.clear();
    }
  };

 }

  
  Template_prototype.setParams = function(objParams) {
    for (var f in objParams)
      this.setParam(f, objParams[f]);
  };

  
  Template_prototype.transform = function(objXML, bObject) {
    if (this.hasError())
      throw new jsx3.Exception(jsx3._msg("temp.temp_err", this.getError()));
    if (objXML.hasError())
      throw new jsx3.Exception(jsx3._msg("temp.doc_err", objXML.getError()));

    try {
      return this._transform(objXML, bObject);
    } catch (e) {
      this.setError(204, jsx3._msg("temp.err", jsx3.NativeError.wrap(e)));
      return null;
    }
  };

  
  Template_prototype.transformToObject = function(objXML) {
    return this.transform(objXML, true);
  };

  

  

  Template_prototype.toString = function() {
    return this._src;
  };

});

jsx3.xml.Entity.jsxclass.mixin(jsx3.xml.Template.prototype, true, ["getError", "hasError", "setError"]);


jsx3.Class.defineClass("jsx3.xml.XslDocument", jsx3.xml.Document, null, function(XslDocument, XslDocument_prototype) {

  
  XslDocument_prototype.setParam = function(strName, objValue) {
    this._getTemplate().setParam(strName, objValue);
  };

  
  XslDocument_prototype.setParams = function(objParams) {
    this._getTemplate().setParams(objParams);
  };

  
  XslDocument_prototype.reset = function() {
    if (this._template) this._template.reset();
  };

  
  XslDocument_prototype.transform = function(objXML) {
    return this._getTemplate().transform(objXML);
  };

  
  XslDocument_prototype.transformToObject = function(objXML) {
    return this._getTemplate().transformToObject(objXML);
  };

  
  XslDocument_prototype._getTemplate = function() {
    if (this._template == null) {
      // will throw error if this has error
      
      this._template = new jsx3.xml.Template(this);
      if (this._template.hasError())
        throw new jsx3.Exception(jsx3._msg("temp.parse", this.getSourceURL(), this._template.getError()));
    }
    return this._template;
  };

  XslDocument_prototype.load = function(strURL) {
    delete this._template;
    return this.jsxsuper(strURL);
  };

  XslDocument_prototype.loadXML = function(strXML) {
    delete this._template;
    return this.jsxsuper(strXML);
  };
  
  XslDocument_prototype.hasError = function() {
    return this.jsxsuper() || (this._template != null && this._template.hasError());
  };

  XslDocument_prototype.getError = function() {
    var objError = null;
    if (this._template) objError = this._template.getError();
    if (! objError) objError = this.jsxsuper();
    return objError;
  };

  
  XslDocument.wrap = function(objXML) {
    return new XslDocument(objXML.getNativeDocument());
  };

  XslDocument_prototype.cloneDocument = function() {
    return XslDocument.wrap(this.jsxsuper());
  };

  XslDocument_prototype.isMutable = function() {
 if (jsx3.CLASS_LOADER.IE) {
   return this._template == null;
 } else {
   return true;
 }
  };

});




jsx3.Class.defineClass("jsx3.xml.Processor", null, null, function(Processor, Processor_prototype) {

  var Template = jsx3.xml.Template;

  Processor.DISABLE_OUTPUT_ESCAPING = 1;

  Processor.supports = function(strKey) {
    return Template.supports(strKey);
  };

  
  Processor_prototype.init = function(objXML, objXSL, objParams) {
    
    this._xml = objXML;
    
    this._xsl = objXSL;
    
    this._params = objParams;
  };

  
  Processor_prototype.setXML = function(objXML) {
    this._xml = objXML;
    return this;
  };

  
  Processor_prototype.setXSL = function(objXSL) {
    this._xsl = objXSL;
    return this;
  };

  
  Processor_prototype.setParams = function(objParams) {
    this._params = objParams;
    return this;
  };

  
  Processor_prototype.transformToObject = function() {
    return this.transform(true);
  };

  
  Processor_prototype.transform = function(bObject) {
    var t = new Template(this._xsl);
    if (! t.hasError()) {
      if (this._params)
        t.setParams(this._params);

      var retVal = t.transform(this._xml, bObject);
      if (! t.hasError())
        return retVal;
    }

    var e = t.getError();
    this.setError(e.code, e.description);
    return null;
  };

  

  

});

jsx3.xml.Entity.jsxclass.mixin(jsx3.xml.Processor.prototype, true, ["getError", "hasError", "setError"]);


